C!MS$OPTIMIZE:'ON:x'
C$DEBUG
      USE DFLIB
C
C    ACUNSF3D+
C
C    **********************************************************
C    *                                                        *
C    *    ****  ****      *****   ****  ****  *****  *        *
C    *        * *   *     *    * *     *      *    * *        *
C    *      **  *   * *** *****  *     *  *** *****  *        *
C    *        * *   *     *      *     *    * *      *        *
C    *    ****  ****      *       ****  ****  *      ******   *
C    *                                                        *
C    **********************************************************
C
C*****3D-PCGPL ( 1-DIMENSIONAL MATRIX -- P.C.G.M ) ***
C
C*****MAIN PROGRAM*******
C(C*****THREE DIMENSIONAL ANALYSIS OF SATURATED-UNSATURATED FLOW
C
C*****DIVELOPED BY M.NISHIGAKI  FEBRUARY,1977 )
C     MODIFIED( SOLVER BY P.C.G.M. ) BY T.SHIRAISHI ( DECEMBER,1986 )
C             (                    )  HELPER Y.TAKESHITA (FOR PC-98)
C     MODIFIED( COLHT              ) BY Y.SHINSHI ( 1992 )
C             ( PC-DOS/V           ) BY MIYO ( 1995 )
C             ( RAIN,BOUND,etc     ) BY T.IMAI ( 2001 )
C             ( @@@@@@@@@ ) BY T.IMAI ( 2005 )
C
      IMPLICIT REAL*8 (A-H,O-Z)  !@{x錾
C
      REAL*4 HED
      CHARACTER*90 ICARD
      CHARACTER*5  INCHA,INCHAO
      CHARACTER*20 FNAME1,FNAME2,FNAME3,FNAME4,FNAME5,FNAME6,FNAME7,
     &             FNAME8,FNAMEIN,FNAMEOUT
C --------------------------ADD IMAI@IGEOL ---------------
      REAL*8 , ALLOCATABLE::BD(:)  !@z̑傫ύXł悤Ȑ錾
      INTEGER , ALLOCATABLE::IB(:)
C
      INCLUDE "RAIN.INC"  !@COMMONǂݍ
      INCLUDE "THQ.INC"
      INCLUDE "TIMECG.INC"
      INCLUDE "MATCHG.INC"
C
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON  /FIX/   HED(20),INIT,MAXIT,INTEG,NSEEP,NTYPE,MAXITO
      COMMON /THREED/ IELD,IEL
      COMMON  /TH1/   NINT,NINTZ
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON / NEFILE / INNEFIL,IFFORM
      COMMON /AD2005/ ICALSW1
C     DIMENSION BD(1000000),IB(1600000)
      DATA MTOTBD,MTOTIB/1000000,1600000/     !@ި̫Ă̔z
      DATA JFIL,IFIL,NOTAPR,NOTAPP/5,1,9,10/
      DATA INCOR,NDPR,ITAP/1,0,0/
      DATA NPMT6/6/                           !@o͐̃t@Cԍ
c      result=SETEXITQQ(QWIN$EXITNOPERSIST)
      MMAX99 = 99
C
      MAXDIM1=0
      MAXDIM2=0
      INFILE =0                             !@WORKt@C̒`
      OPEN(98,FILE='WORK.LST',STATUS='OLD',FORM='FORMATTED')
      READ(98,'(A20)') FNAME1         !@et@CȂǂ̓ǂݍ
      READ(98,'(A20)') FNAME2
      READ(98,'(A20)') FNAME3
      READ(98,'(A20)') FNAME4
      READ(98,'(A20)') FNAME7
      READ(98,'(A20)') FNAME8
      READ(98,*,END=1200) MAXDIM1
      READ(98,*,END=1200) MAXDIM2
      READ(98,'(A20)',END=1200) FNAMEIN
      READ(98,'(A20)') FNAMEOUT
      CLOSE(98)
      GO TO 1201    
 1200 CONTINUE
      INFILE =1
 1201 CONTINUE
      IF(MAXDIM1 .GT. 0) THEN
      MTOTBD = MAXDIM1
      END IF
      IF(MAXDIM2 .GT. 0) THEN
      MTOTIB = MAXDIM2
      END IF
      ALLOCATE( BD(MTOTBD))         !@z̐錾
      ALLOCATE( IB(MTOTIB))
      IF(FNAMEIN.EQ."" .OR. FNAMEOUT .EQ. "") INFILE =0
C============================================================= FILE OPEN
C   @@@[Nt@C̒`
      OPEN (2,FILE=FNAME2,STATUS='UNKNOWN',FORM='UNFORMATTED')
      OPEN (3,FILE=FNAME3,STATUS='UNKNOWN',FORM='UNFORMATTED')
      OPEN (4,FILE=FNAME4,STATUS='UNKNOWN',FORM='UNFORMATTED')
      OPEN (1,FILE=FNAME1,STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN (9,FILE=FNAME7,STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN (10,FILE=FNAME8,STATUS='UNKNOWN',FORM='FORMATTED')
C-------------------------------------- READ CONTORL DATA FROM FILE NO.5
      IF(INFILE .EQ. 1)THEN
      WRITE (*,200)
      READ (*,'(A20)') FNAME5    !̓f[^t@C̓ǂݍ
C 
C---------------------------------------- ALL RESULTS WRITE TO FILE NO.6
      WRITE (*,210)
      READ (*,'(A20)') FNAME6    !o̓t@C̓ǂݍ
      ELSE
      FNAME5 = FNAMEIN
      FNAME6 = FNAMEOUT
      END IF
C@@@@@@@@@́Eo̓t@C̒`
      OPEN (5,     FILE=FNAME5, STATUS='OLD',FORM='FORMATTED')
      OPEN (NPMT6, FILE=FNAME6, STATUS='UNKNOWN',FORM='FORMATTED')
  200 FORMAT(//' KEY IN INPUT DATA FILE NAME [EX. B:DATA1.DAT] ====> ')
  210 FORMAT(/ ' KEY IN OUTPUT FILE NAME     [EX. B:DATA1.PRN] ====> ')
C-----------------------------------------------------------------------
      IF( JFIL.NE. 5)  REWIND JFIL     !̓f[^t@C
      IF( JFIL.NE. 5)  REWIND IFIL     !̃GR[vg̏
      NCARD = 0
 1110 NCARD = NCARD + 1
      READ(JFIL,1100,END =1120) ICARD
C
      WRITE(IFIL,1100) ICARD
C--------- MIYO
 1130 FORMAT(1H1,////,19X,'1',9X,'2',9X,'3',9X,'4',9X,'5',9X,'6',9X,'7',
     & 9X,'8',/,3X,'NUMBER 1...5....0',7(10H....5....0))
 1100 FORMAT(A90)
 1140 FORMAT(4X,I5,1X,A80)
      GO TO 1110
 1120 IF( IFIL.NE.5) REWIND IFIL
C
      NERR=0
C
C------------------------------------------------------- READ HEAD TITLE
C
      READ(IFIL,20)HED    !Group-A̓ǂݍ
   20 FORMAT(20A4)
C
C---------------------------------------------- READ GENERAL INFORMATION
C                         Group-B̓ǂݍ
      READ (IFIL,32) NUMNP,NUMEL,NUMMAT,INIT,MAXIT,INTEG,NSEEP,
     1            MXNODS,NINT,NINTZ,NCUL,NTYPE,MAXITO,ITMAX,INCORE ,MSCK
   32 FORMAT (2I7,I6,11I5,I2,I3)
C
      IF(INCORE .EQ. 1) INCOR = 0   !t@Cgp
      IF(INCORE .EQ. 0) INCOR = 1   !gp
C! Zoʃf[^tH[}bg̕ύX
      MAXS = 1
C
      IADDDA= 1 
C --------------------------ADD IMAI@IGEOL ---------------
C                   ϐ̃[NA
      NERAIN = 0
      NRAIN  = 0
      MRK  = 0 
      MRP  = 0
      MEK  = 0
      MEP  = 0
      INCON = 0
      NBOUN = 0
      MNBN= 0 
      MIHT= 0 
      NQBOUN = 0
      MNQBN = 0 
      MIQT = 0
      NBCTIME = 0
      NBCHTIM = 0
      NBCQTIM = 0
      NBCBOUN = 0
      MATCTIME = 0
      MATCELEM = 0
      MATCMAT  = 0
      INNEFIL = 0
      IFFORM = 0
	IPEMOD = 0
C                                                        
      IF(IADDDA .EQ. 1) THEN
C                                      Group-BA̓ǂݍ
      READ (IFIL,30) NBOUN,MNBN,MIHT,NQBOUN,MNQBN,MIQT
      NBOUN1=NBOUN                                                          
      MNBN1=MNBN                                                            
      MIHT1=MIHT                                                            
C
      NQBOUN1=NQBOUN                                                          
      MNQBN1=MNQBN                                                            
      MIQT1=MIQT                                                            
C                                      Group-BB̓ǂݍ
      READ (IFIL,31) NERAIN,NRAIN,MRK,MRP,MEK,MEP,PL
      NERAIN1 = NERAIN
      NRAIN1 = NRAIN
      MRK1 = MRK 
      MRP1 = MRP
      MEK1 = MEK
      MEP1 = MEP
C                                      Group-BC̓ǂݍ݁@@@@@@@@@@
      READ (IFIL,30) INCON,INVAL,ITSW,INNEFIL,IFFORM,ICALSW1
   31 FORMAT(6I5,F10.0)
C                                      Group-BD̓ǂݍ݁@ 
      READ(IFIL,30) NBCTIME,NBCHTIM,NBCQTIM,NBCBOUN,NBCRTIM
      NBCTIME1=NBCTIME
      NBCHTIM1=NBCHTIM
      NBCQTIM1=NBCQTIM
      NBCBOUN1=NBCBOUN
      NBCRTIM1=NBCRTIM
C                                      Group-BE̓ǂݍ
      READ(IFIL,30) MATCTIME,MATCELEM,MATCMAT 
      MATCTIME1 = MATCTIME
      MATCELEM1=MATCELEM
      MATCMAT1=MATCMAT
      END IF
      IF( NUMMAT .GT.MMAX99) STOP 2222
C
C                    _Ci~bNAP[Vׂ̈̏
      IF(NERAIN .LT. 1) NERAIN1=1
      IF(NRAIN  .LT. 1) NRAIN1=1
      IF(MRK .LT. 1) MRK1= 1
      IF(MRP .LT. 1) MRP1= 1
      IF(MEK .LT. 1) MEK1= 1
      IF(MEP .LT. 1) MEP1= 1
C
      IF(NBOUN .LT.1) NBOUN1=1                                              
      IF(MNBN .LT. 1) MNBN1=1                                              
      IF(MIHT .LT. 1) MIHT1=1 
C
      IF(NQBOUN .LT.1) NQBOUN1=1                                              
      IF(MNQBN .LT. 1) MNQBN1=1                                              
      IF(MIQT .LT. 1) MIQT1=1
C
      IF(NBCTIME .LT.1) NBCTIME1=1                                              
      IF(NBCHTIM .LT. 1) NBCHTIM1=1                                              
      IF(NBCQTIM .LT. 1) NBCQTIM1=1
      IF(NBCRTIM .LT. 1) NBCRTIM1=1
      IF(NBCBOUN .LT. 1) NBCBOUN1=1
C
      IF(MATCTIME .LT. 1) MATCTIME1 =1
      IF(MATCELEM .LT. 1) MATCELEM1 =1
      IF(MATCMAT .LT. 1) MATCMAT1   =1
C
      NUM2T = MATCTIME1 + NBCTIME1+MRK1+MEK1+MIHT1+MIQT1 
C
   30 FORMAT (16I5)
C
      IF(  MXNODS .NE. 8)  MXNODS=8
      IF( ITMAX .EQ. 0 ) ITMAX = 5
      ITMAX=NUMNP*ITMAX     !PCG@̌JԂ̐ݒ
      MAXSP=1
      NDIM=1
      IF(NSEEP.LT.1 ) GO TO 50
      NDIM=NSEEP            !Zoʃf[^̐ݒ
      MAXSP=MAXS
C

   50 READ (IFIL,30)(NUMK(J),NUMP(J),J=1,NUMMAT)  !Group-C̓ǂݍ
C
C        sOå֌W̐ݒ
      MK=NUMK(1)
      MP=NUMP(1)
      IF( NUMMAT .EQ. 1) GO TO 70
      DO 60 J=2,NUMMAT
      IF( NUMK(J) .GT. MK) MK=NUMK(J)
      IF( NUMP(J) .GT. MP) MP=NUMP(J)
   60 CONTINUE
   70 NDM = 3*MXNODS
      MXX = MXNODS*MXNODS
      NUMNP1 = NUMNP + 1
C
C----------------------------------------------------- STORAG ALLOCATION
C  N-TYPE INTEGER ARRAY
C  M-TYPE REAL*8  ARRAY
C                  _Ci~bNAP[VɂzAhX̌vZ
       N1 = 1
       N2 = N1 + NUMEL
       N3 = N2 + NUMEL*MXNODS
       N4 = N3 + NUMNP
       N5 = N4 + NDIM*MAXSP
       N6 = N5 + NDIM
       N6B= N6 + NUMNP1
       N7 = N6B+ NUMEL
C
       M1 = 1
       M2 =  M1 + MK*NUMMAT
       M3 =  M2 + MK*NUMMAT
       M4 =  M3 + MP*NUMMAT
       M5 =  M4 + MP*NUMMAT
       M6 =  M5 + MP*NUMMAT
       M7 =  M6 + MP*NUMMAT
       M8 =  M7 + NUMNP
       M9 =  M8 + NUMNP
      M9B =  M9 + NUMNP
      M10 = M9B + NUMNP
      M11 = M10 + NUMNP
      M12 = M11 + NUMNP
      M13 = M12 + NUMNP
C
      WRITE(NPMT6,380)M13-1,N7-1
C  
  380 FORMAT(///,'  MESH CHECK DIMENSION'
     1           '  BD( ',I10,' )','IB( ',I10,')')
C
      IF(M13-1 .LE. MTOTBD .AND. N7-1 .LE. MTOTIB ) GO TO 500
      MOT1=M13-1-MTOTBD
      MOT2=N7-1 -MTOTIB
      WRITE(NPMT6,390) MOT1,MOT2
C 
  390 FORMAT(//' MTOTBD=',I10,'  MTOTIB=',I10)
      STOP 1111
C
C-------------------------------- READ AND  GENERATE ELEMENT INFORMATION
C @@@@@@@@@@@@vf\iGroup-Dj̓ǂݍ
  500 CALL MAFIL ( IB(N1),IB(N2),IB(N6B),NUMEL,MXNODS )
C
C----------------------------------------- READ SEEPAGE FACE INFORMATION
C
      IF (NSEEP .GE. 1 ) THEN
C @@@@@@@@@@@@ZoʁiGroup-E,EAj̓ǂݍ
       CALL SEEFAC ( IB(N4),IB(N5),NSEEP,NDIM,MAXSP )
C
C--------------------------- READ GENERAL INFORMATION  (TIME INFORMATION)
C
      END IF
      INCHAO = INCHA 
C @@@@@@@@@@@@ԃf[^iGroup-Fj̓ǂݍ
  330 READ (IFIL,340) INCHA,DT,DTMAX,DMUL,TMAX,TOL,NPRINT,NPLOT
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE."TIME ")   WRITE(NPMT6,341)
  340 FORMAT (A5,5E10.3,2I5)
  341 FORMAT (" ** ERROR ** TIME STEP DATA -- Group F ")
      IF( NPRINT .LE. 0 ) NPRINT =1
      IF( NPLOT  .LE. 0 ) NPLOT  =1
C
C--------------------------------- READ AND GENERATE MATERIAL INFORMATION
C @@@@@@@@@@@@ގiGroup-G,H,IJ,I,Jj̓ǂݍ
      CALL MATIN ( BD(M1),BD(M2),BD(M3),BD(M4),BD(M5),BD(M6),
     1             MK,MP,NUMMAT)
C
C------------------------------ READ AND GENERATE NODAL POINT INFORMATION
C
C @@@@@@@@@@@@ߓ_iGroup-K,KA,KBj̓ǂݍ
      CALL NPIN ( IB(N3),BD(M7),BD(M8),BD(M9),BD(M10),BD(M11),
     1            BD(M12),BD(M9B),NUMNP,INIT,NERR,INCON,INVAL )
C
c      IF (NERR .GT. 0) STOP 2222
C
C     WRITE(*,600)
C 600 FORMAT(//' ***** ALL INPUT DATA HAVE BEEN READ *****')
C
C------------------------------------ WRITE MESH CHECK DATA TO 15TH FILE
C
C @@@@@@@@@@@@􉽌`̃t@Co
      CALL MESCHK (IB(N2),IB(N3),BD(M10),BD(M11),BD(M12),BD(M8),
     &            BD(M7),IB(N1),HED,NUMNP,NUMEL,MXNODS )
C
      CALL MESHERR (BD(M10),BD(M11),BD(M12),IB(N2),MXNODS,
     1                     IB(N6B),NUMNP,NUMEL,IERSW)
C
      IF (NERR .GT. 0 .OR. IERSW .EQ. 1) GO TO 412
      IF( MSCK .LT. 1 ) GO TO 400
C
C        bV`FbN݂̂̏ꍇɏI
  412 CONTINUE
      CALL PLODAT2( BD(M8),BD(M7),IB(N3),NUMNP, NUMEL    )
      WRITE(NPMT6,710)
  710 FORMAT(//'  ***** MESH CHECK ONLY !!!! *****')
      GO TO 700
C
C---------- CALUCULATE ADDRESSES OF DIAGONAL ELEMENT AND MAXIMUM STORAGE
C
  400 M14 = M13 + 2*NUMEL
C
      WRITE(NPMT6,380)M14-1,N7-1
C
      IF(M14-1 .LE. MTOTBD .AND. N7-1.LE. MTOTIB ) GO TO 555
      MOT1=M14-1-MTOTBD
      WRITE(NPMT6,390) MOT1,MOT2
      STOP 3333
C @@@@@@@@@@@@}gbNX1zTCY̌vZ
  555 CALL COLHT ( IB(N2),IB(N6),BD(M13),IB(N6B),NUMNP,NUMNP1,NUMEL,
     1              MXNODS,NWK)
C
      N8 = N7 + NWK
C
      WRITE(NPMT6,380)M14-1,N8-1
C
      IF(M14-1 .LE. MTOTBD .AND. N8-1.LE. MTOTIB ) GO TO 556
      MOT2=N8-1-MTOTIB
      WRITE(NPMT6,390) MOT1,MOT2
C
      STOP 4444
C
C @@@@@@@@@@@@}gbNX̊eW̊i[Ԓn̐ݒ
  556 CALL ADRSK( IB(N2),IB(N6),IB(N7),IB(N6B),NUMNP,NUMNP1,NUMEL,
     1            MXNODS,NWK)
C
C                  _Ci~bNAP[VɂzAhX̌vZ
      N10 = N8 + NUMNP
      M14 = M13 + NWK
      M15 = M14 + NUMNP
      M16 = M15 + NUMNP
      M17 = M16 + NUMNP
      M18 = M17 + NDM
      M19 = M18 + NDM
      M20 = M19 + MXX
      M21 = M20 + NUMNP
C---  INCOR=0 EXTERIA-DISK  INCOR=1 MEMORY
      NWKT = NWK
      NMNPT= NUMNP
      NMELT= NUMEL
      IF( INCOR .NE. 1 ) THEN
       NWKT = 1
       NMNPT= 1
       NMELT= 1
      END IF
  800 N11=N10 + NMNPT
      M22=M21 + NWKT
      M23=M22 + NMNPT
      M24=M23 + NMNPT
      M25=M24 + NMNPT
      M26=M25 + NMNPT
      M26B=M26 + NMNPT
      M27=M26B + NMNPT
C
C --------------------------ADD IMAI@IGEOL ---------------
C
      N12=N11 + NRAIN1
      N13=N12 + NERAIN1
      N14=N13 + NERAIN1
      N15=N14 + NERAIN1*7
      N16=N15 + MRP1
      N17=N16 + MEP1
      N18=N17 + NBOUN1
      N19=N18 + NBOUN1*MNBN1
      N20=N19 + NBOUN1
      N21=N20 + NQBOUN1
      N22=N21 + NQBOUN1*MNQBN1
      N23=N22 + NQBOUN1
      N24=N23 + NBCTIME1
      N25=N24 + NBCTIME1*NBCHTIM1
      N26=N25 + NBCTIME1*NBCHTIM1
      N27=N26 + NBCTIME1*NBCHTIM1
      N28=N27 + NBCTIME1
      N29=N28 + NBCTIME1*NBCQTIM1
      N30=N29 + NBCTIME1*NBCQTIM1
      N31=N30 + NBCTIME1*NBCQTIM1
      N32=N31 + NBCTIME1
      N33=N32 + NBCTIME1*NBCBOUN1
      N34=N33 + NBCTIME1*NBCBOUN1
      N35=N34 + NBCTIME1*NBCBOUN1
      N36=N35 + NBCTIME1*NBCBOUN1
      N37=N36 + MATCTIME1
      N38=N37 + MATCTIME1*MATCELEM1 
      N39=N38 + MATCTIME1*MATCELEM1
      N40=N39 + MATCTIME1 
      N41=N40 + MATCTIME1*MATCMAT1
      N42=N41 + MATCTIME1*MATCMAT1
      N43=N42 + NMELT
      N44=N43 + NBCTIME1
      N45=N44 + NBCTIME1*NBCRTIM1
      N46=N45 + NBCTIME1*NBCRTIM1
      N47=N46 + NBCTIME1*NBCRTIM1
      N48=N47 + NBCTIME1*NBCRTIM1
      N49=N48 + NBCTIME1*NBCRTIM1
      N50=N49 + NUMEL
	N51=N50 + NUMNP
C
      M28=M27 + NERAIN1*2
      M29=M28 + NRAIN1
      M30=M29 + MRK1*MRP1
      M31=M30 + MRK1*MRP1
      M32=M31 + MEK1*MEP1
      M33=M32 + MEK1*MEP1
      M34=M33 + MIHT1*NBOUN1
      M35=M34 + MIHT1*NBOUN1
      M36=M35 + MIQT1*NQBOUN1
      M37=M36 + MIQT1*NQBOUN1
      M38=M37 + NQBOUN1*MNQBN1
      M39=M38 + NBCTIME1 
      M40=M39 + MATCTIME1
      M41=M40 + NBCTIME1*NBCBOUN1
      M42=M41 + NBCTIME1*NBCBOUN1
      M43=M42 + NBCTIME1*NBCRTIM1
      M44=M43 + NUM2T
C
C          Kvȃ}gbNX̔z񐔂̕\
      WRITE(NPMT6,80)M44-1,N51-1
C 
   80 FORMAT(//'  TOTAL DIMENSION  BD( ',I10,' )'/
     1         '  TOTAL DIMENSION  IB( ',I10,' )')
C
      IF(M44-1.LE. MTOTBD .AND. N51-1 .LE. MTOTIB) GO TO 100
      MOT1=M44-1-MTOTBD
      MOT2=N51-1-MTOTIB
      WRITE(NPMT6,90) MOT1,MOT2
C
   90 FORMAT(//'  MTOTBD= ',I7,'  MTOTIB= ',I7)
      STOP 5555
C
C-------------------------------------------------------- PRINT HED TITLE
C
  100 CONTINUE
C          {ݒ̈
      IF( NTYPE .LE. -1 )  WRITE(NPMT6,345)
      IF( NTYPE .GE.  1 )  WRITE(NPMT6,346)
      IF( NTYPE .EQ.  0 )  WRITE(NPMT6,347)
  345 FORMAT(' ***** UNSTEADY PROBLEM *******'/)
  346 FORMAT(' ******* STEADY PROBLEM *******'/)
  347 FORMAT(' ******* STEADY-UNSTEADY PROBLEM *******'/)
  342 WRITE(NPMT6,350)HED,NUMNP,MXNODS,NUMEL,NUMMAT,MAXIT,MAXITO,
     1                ITMAX,NWK
  350 FORMAT (1X,20A4//30H NUMBER OF NODAL POINTS------- I7/
     1                  30H MAX NODES IN A ELEMENT------- I7/
     2                  30H NUMBER OF ELEMENTS----------- I7/
     3                  30H NUMBER OF MATERIALS---------- I7/
     4                  30H MAX NUMBER OF ITERATIONS----- I7/
     5                  30H MAX NUMBER OF ITERATIONS(T=0) I7/
     6                  30H MAX NUMBER OF CG ITERATIONS-- I7/
     7                  30H NUMBER OF MATRIX DIMENSIONS-- I7///)
C
C ---------------------------------------- READ RAIN DATA
C --------------------------ADD IMAI@IGEOL ---------------
C 
      IF(NERAIN .GT. 0) THEN
C @@@@@@@@@@@@~JiGroup-L,LA,LB,LCj̓ǂݍ
      CALL RRAINDAT(IB(N2),BD(M10),BD(M11),NUMNP,MXNODS,NUMEL,
     1 IB(N11),IB(N12),IB(N13),IB(N14),IB(N15),IB(N16),IB(N6B),
     2 BD(M27),BD(M29),BD(M30),BD(M31),BD(M32),0  )
      END IF
C
C
C @@@@@@@@@@@@vvZ[`̃R[
      CALL FEM( BD(M1),BD(M2) ,BD(M3) ,BD(M4) ,BD(M5) ,BD(M6) ,BD(M7) ,
     1BD(M8) ,BD(M9) ,BD(M10),BD(M11),BD(M12),BD(M13),BD(M14),BD(M15),
     2BD(M16),BD(M17),BD(M18),BD(M19),BD(M20),BD(M21),BD(M22),BD(M23),
     3BD(M24),BD(M25),BD(M26),
     3IB(N1),IB(N2),IB(N3),IB(N4),IB(N5),IB(N6),IB(N7),IB(N8),
     3IB(N10),
     4NWK,NUMNP,NUMNP1,NUMEL,MXNODS,NUMMAT,MK,MP,NDIM,MAXSP,NCUL,NDM,
     5MXX,ITMAX,DT,DTMAX,TMAX,DMUL,TOL ,
     6NWKT,NMNPT,NPRINT,NPLOT,NMELT,ITSW,
     7 IB(N11),IB(N12),IB(N13),IB(N14),IB(N15),IB(N16),
     8 BD(M27),BD(M28),BD(M29),BD(M30),BD(M31),BD(M32),
     9 IB(N6B),BD(M9B),BD(M26B),
     1 IB(N17),IB(N18),IB(N19),IB(N20),IB(N21),IB(N22),
     1 BD(M33),BD(M34),BD(M35),BD(M36),BD(M37),
     1 BD(M38),IB(N23),IB(N24),IB(N25),IB(N26),IB(N27),
     1 IB(N28),IB(N29),IB(N30),IB(N31),BD(M40),IB(N32),
     1 BD(M41),IB(N33),IB(N34),IB(N35),BD(M39),IB(N36),IB(N37),
     1 IB(N38),IB(N39),IB(N40),IB(N41),IB(N42),
     1 IB(N43),IB(N44),IB(N45),IB(N46),IB(N47),IB(N48),
     1 BD(M42),BD(M43),IB(N49),IB(N50),NUM2T)
C
C   I
  700 WRITE(NPMT6,140)
  140 FORMAT(//'  ***GOOD, GOOD****')
C     WRITE (*,220)
C
C 200 FORMAT(1H0,'== INPUT DATA FILE NAME [ EX. B:DATA1.DAT ] ====> '\)
C 210 FORMAT(1H0,'= OUTPUT DATA FILE NAME [ EX. B:DATA1.OUT ] ====> '\)
C 220 FORMAT(1H0,' <<<<<  NORMAL TERMINATION  >>>>> ')
      STOP
      END
      SUBROUTINE FEM( XK,YK,XP,YP,XC,YC,Q,P,P1,X,Y,Z,
     1                A,B,PP,C,B1,XYZ,E,SD,
     1                AD2,BD2,PD3,PD13,QD3,PD4,
     1                MATP,NODE,KODE,NP,NSP,IS,ISP,NKODE,KODE3,
     2         NWK,NUMNP,NUMNP1,NUMEL,MXNODS,NUMMAT,MK,MP,NDIM,
     2         MAXSP,NCUL,NDM,MXX,ITMAX,DT,DTMAX,TMAX,DMUL,TOL ,
     3         NWKT,NMNPT,NPRINT,NPLOT,NMELT,ITSW,
     4         NRAINP,ICAPA,IEVAP,IERAIN,NUMRAIN,NUMEVAP,
     4         CAPA,RRDUM,XRP,YRP,XEP,YEP,
     5         ITYPE,QINIT,QINIT3,NBN,NBOU,NIHT,NBNQ,NBOUQ,NIQT,
     6         XH,YH,XQ,YQ,QDATA,BCTIME,NBCHTNN,NBCHTND,NBCHTSW,
     1         NBCHTP,NBCQTNN,NBCQTND,NBCQTSW,NBCQTP,NBCNN,
     1         HEADNBC,NBCCQ,QNBC,NBCND,NBCKCON,NBCCH,
     1         PCTIME,MATCNE,MATCE,MATCEM,MATCNM,MATCM,MATCMM,
     1         MATP3,NBCRNN,NBCRND,NBCRSW,NBCRRP,NBCREP,NBCRMEN,
     1         CAPANBCR,TIMEON,ISWE,ISWN,NUM2T)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C     IMPLICIT INTEGER*2 (I-N)
      REAL*4 HED
C     CHARACTER*72 HED
      CHARACTER*80 COMMT
      CHARACTER*5  INCHA,INCHAO
C --------------------------ADD IMAI@IGEOL ---------------
C
      INCLUDE "RAIN.INC"
      INCLUDE "THQ.INC"
      INCLUDE "TIMECG.INC"
      INCLUDE "MATCHG.INC"
C
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /FIX/ HED(20),INIT,MAXIT,INTEG,NSEEP,NTYPE,MAXITO
      COMMON /THREED/ IELD,IEL
      COMMON /TH1/ NINT,NINTZ
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION A(NWK),B(NUMNP),PP(NUMNP),KODE(NUMNP),Q(NUMNP),
     1          P(NUMNP),P1(NUMNP),C(NUMNP),X(NUMNP),Y(NUMNP),Z(NUMNP),
     2          MATP(NUMEL),NODE(MXNODS,NUMEL),
     3          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     4          XC(MP,NUMMAT),YC(MP,NUMMAT),
     5          B1(NDM),XYZ(NDM),E(MXX),NP(NDIM,MAXSP),NSP(NDIM),
     6          ISP(NWK),IS(NUMNP1),NKODE(NUMNP),SD(NUMNP)
      DIMENSION PD3(NMNPT),PD13(NMNPT),QD3(NMNPT),KODE3(NMNPT),
     1          AD2(NWKT),BD2(NMNPT),PD4(NMNPT)
      DIMENSION ITYPE(NUMEL),QINIT(NUMNP),QINIT3(NMNPT)
      DIMENSION NRAINP(NRAIN1),CAPA(NERAIN1,2),ICAPA(NERAIN1),
     1       IEVAP(NERAIN1),RRDUM(NRAIN1),XRP(MRK1,MRP1),YRP(MRK1,MRP1),
     2       XEP(MEK1,MEP1),YEP(MEK1,MEP1),IERAIN(NERAIN1,7),
     3       NUMRAIN(MRP1),NUMEVAP(MEP1)
      DIMENSION NBN(NBOUN1),NBOU(NBOUN1,MNBN1),XH(MIHT1,NBOUN1),
     1          YH(MIHT1,NBOUN1),NIHT(NBOUN1)
      DIMENSION NBNQ(NQBOUN1),NBOUQ(NQBOUN1,MNQBN1),XQ(MIQT1,NQBOUN1),
     1          YQ(MIQT1,NQBOUN1),NIQT(NQBOUN1),QDATA(NQBOUN1,MNQBN1)
      DIMENSION BCTIME(NBCTIME1),NBCHTNN(NBCTIME1),
     1 NBCHTND(NBCTIME1,NBCHTIM1),NBCHTSW(NBCTIME1,NBCHTIM1),
     1 NBCHTP(NBCTIME1,NBCHTIM1),      NBCQTNN(NBCTIME1),
     1 NBCQTND(NBCTIME1,NBCQTIM1),NBCQTSW(NBCTIME1,NBCQTIM1),
     1 NBCQTP(NBCTIME1,NBCQTIM1),      NBCNN(NBCTIME1),
     1 HEADNBC(NBCTIME1,NBCBOUN1),NBCCQ(NBCTIME1,NBCBOUN1),
     1 QNBC(NBCTIME1,NBCBOUN1),NBCND(NBCTIME1,NBCBOUN1),
     1 NBCKCON(NBCTIME1,NBCBOUN1),NBCCH(NBCTIME1,NBCBOUN1),
     1  PCTIME(MATCTIME1),MATCNE(MATCTIME1),MATCE(MATCTIME1,MATCELEM1),
     1  MATCEM(MATCTIME1,MATCELEM1),MATCNM(MATCTIME1),
     1  MATCM(MATCTIME1,MATCMAT1),MATCMM(MATCTIME1,MATCMAT1)
      DIMENSION MATP3(NMELT),NBCRNN(NBCTIME1),
     1 NBCRND(NBCTIME1,NBCRTIM1),NBCRSW(NBCTIME1,NBCRTIM1),
     1 NBCRRP(NBCTIME1,NBCRTIM1), NBCREP(NBCTIME1,NBCRTIM1),
     1 NBCRMEN(NBCTIME1,NBCRTIM1), CAPANBCR(NBCTIME1,NBCRTIM1)
      DIMENSION TIMEON(NUM2T),ISWE(NUMEL),ISWN(NUMNP)
C
C***********************************************************************
C
C     IB(N1)---MATP(NUMEL)
C     IB(N2)---NODE(MXNODS,NUMEL)
C     IB(N3)---KODE(NUMNP)
C     IB(N4)---NP(NDIM,MAXSP)
C     IB(N5)---NSP(NDIM)
C     IB(N6)---IS(NUMNP1)
C     IB(N7)---ISP(NWK)
C     IB(N8)---NKODE(NUMNP)
C     IB(N10)--KODE3(NMNPT)
C
C     BD(M1)---XK(MK,NUMMAT)
C     BD(M2)---YK(MK,NUMMAT)
C     BD(M3)---XP(MP,NUMMAT)
C     BD(M4)---YP(MP,NUMMAT)
C     BD(M5)---XC(MP,NUMMAT)
C     BD(M6)---YC(MP,NUMMAT)
C     BD(M7)---Q(NUMNP)
C     BD(M8)---P(NUMNP)
C     BD(M9)---P1(NUMNP)
C     BD(M10)--X(NUMNP)
C     BD(M11)--Y(NUMNP)
C     BD(M12)--Z(NUMNP)
C     BD(M13)--A(NWK)
C     BD(M14)--B(NUMNP)
C     BD(M15)--PP(NUMNP)
C     BD(M16)--C(NUMNP)
C     BD(M17)--B1(NDM)
C     BD(M18)--XYZ(NDM)
C     BD(M19)--E(MXX)
C     BD(M20)--SD(NUMNP)
C     BD(M21)--AD2(NWKT)
C     BD(M22)--BD2(NMNPT) 
C     BD(M23)--PD3(NMNPT)
C     BD(M24)--PD13(NMNPT)
C     BD(M25)--QD3(NMNPT)
C     BD(M26)--PD4(NMNPT)
C
C --------------------------ADD IMAI@IGEOL ---------------
C     IB(N6B)--ITYPE(NUMEL)
C     IB(N11)--NRAINP(NRAIN1)
C     IB(N12)--ICAPA(NERAIN1)
C     IB(N13)--IEVAP(NERAIN1)
C     IB(N14)--IERAIN(NERAIN1,7)
C     IB(N15)--NUMRAIN(MRP1)
C     IB(N16)--NUMEVAP(MEP1)
C     IB(N17)--NBN(NBOUN1)
C     IB(N18)--NBOU(NBOUN1,MNBN1)
C     IB(N19)--NIHT(NBOUN1)
C     IB(N20)--NBNQ(NQBOUN1)
C     IB(N21)--NBOUQ(NQBOUN1,MNQBN1)
C     IB(N22)--NIQT(NQBOUN1)
C     IB(N23)--NBCHTNN(NBCTIME1)
C     IB(N24)--NBCHTND(NBCTIME1,NBCHTIM1)
C     IB(N25)--NBCHTSW(NBCTIME1,NBCHTIM1)
C     IB(N26)--NBCHTP(NBCTIME1,NBCHTIM1)
C     IB(N27)--NBCQTNN(NBCTIME1)
C     IB(N28)--NBCQTND(NBCTIME1,NBCQTIM1)
C     IB(N29)--NBCQTSW(NBCTIME1,NBCQTIM1)
C     IB(N30)--NBCQTP(NBCTIME1,NBCQTIM1)
C     IB(N31)--NBCNN(NBCTIME1)
C     IB(N32)--NBCCQ(NBCTIME1,NBCBOUN1)
C     IB(N33)--NBCND(NBCTIME1,NBCBOUN1)
C     IB(N34)--NBCKCON(NBCTIME1,NBCBOUN1)
C     IB(N35)--NBCCH(NBCTIME1,NBCBOUN1)
C     IB(N36)--MATCNE(MATCTIME1)
C     IB(N37)--MATCE(MATCTIME1,MATCELEM1) 
C     IB(N38)--MATCEM(MATCTIME1,MATCELEM1)
C     IB(N39)--MATCNM(MATCTIME1) 
C     IB(N40)--MATCM(MATCTIME1,MATCMAT1)
C     IB(N41)--MATCMM(MATCTIME1,MATCMAT1)
C     IB(N42)--MATP3(NMELT)
C     IB(N43)--NBCRNN(NBCTIME1)
C     IB(N44)--NBCRND(NBCTIME1,NBCRTIM1)
C     IB(N45)--NBCRSW(NBCTIME1,NBCRTIM1)
C     IB(N46)--NBCRRP(NBCTIME1,NBCRTIM1)
C     IB(N47)--NBCREP(NBCTIME1,NBCRTIM1)
C     IB(N48)--NBCMEN(NBCTIME1,NBCRTIM1)
C     IB(N49)--ISWE(NUMEL)
C     IB(N50)--ISWN(NUMNP)
C
C     BD(M9B)--QINIT(NUMNP)
C     BD(M26B)--QINIT3(NMNPT)
C     BD(M27)--CAPA(NERAIN1,2)
C     BD(M28)--RRDUM(NRAIN1)
C     BD(M29)--XRP(MRK1,MRP1)
C     BD(M30)--YRP(MRK1,MRP1)
C     BD(M31)--XEP(MEK1,MEP1)
C     BD(M32)--YEP(MEK1,MEP1)
C     BD(M33)--XH(MIHT1,NBOUN1)
C     BD(M34)--YH(MIHT1,NBOUN1)
C     BD(M35)--XQ(MIQT1,NQBOUN1)
C     BD(M36)--YQ(MIQT1,NQBOUN1)
C     BD(M37)--QDATA(NQBOUN1,MNQBN1)
C     BD(M38)--BCTIME(NBCTIME1) 
C     BD(M39)--PCTIME(MATCTIME1)
C     BD(M40)--HEADNBC(NBCTIME1,NBCBOUN1)
C     BD(M41)--QNBC(NBCTIME1,NBCBOUN1)
C     BD(N42)--CAPANBCR(NBCTIME1,NBCRTIM1)
C     BD(N43)--TIMEON(NUM2T)
C
C***********************************************************************
      CEPS = 1.0E-4
      CEPS2= 1.0E-3
      IKNOW = 0
      KNOW = 1
	NERR = 0
C @@@@@@@@@@@@ʂ̎ԕωf[^iGroup-M,NO,N,Oj̓ǂݍ
      IF(NBOUN .GE.1 ) CALL READTH(NBN,NBOU,NIHT,XH,YH,NERR)
C @@@@@@@@@@@@ʂ̎ԕωf[^iGroup-R,ST,S,Tj̓ǂݍ
      IF(NQBOUN.GE.1 ) CALL READTQ(NBNQ,NBOUQ,NIQT,XQ,YQ,NERR)
C 
      IF(NBCTIME .GE. 1 ) THEN
C
C @@@@@@@@@@@@EύXf[^iGroup-U,UA,UB,UC,UDjǂݍ
      CALL READNBC(Z,BCTIME,NBCHTNN,NBCHTND,NBCHTSW,
     1       NBCHTP, NBCQTNN,NBCQTND,NBCQTSW,NBCQTP,NBCNN,
     2       HEADNBC,NBCCQ,QNBC,NBCND,NBCKCON,NBCCH,
     3       NBCRNN,NBCRND,NBCRSW,NBCRRP, NBCREP,NBCRMEN,
     4       CAPANBCR ,NUMNP,NERR)
C
      END IF
C  323 FORMAT(A5,6F10.0)
C  394 FORMAT(" ** ERROR ** ",A5," DATA -- Group ",A3)
C
C@@@@@@@@@@@@ގύXf[^iGroup-V,VA,VBjǂݍ
      IF(MATCTIME .GE. 1) THEN
       CALL  READMC(PCTIME,MATCNE,MATCE,MATCEM,MATCNM,MATCM,MATCMM,NERR)
      END IF
C
      IF(NERR .EQ. 1) STOP 3333
C
C
C ގԍ̏ꍇ̏{gpȂߓ_̏
C
      CALL  INISET(ISWE,ISWN,KODE,NODE,MATP,
	1         NUMNP,NUMEL,MXNODS) 
C
C!              EAގύXԂKvZԂʉ߂悤
C!              dԂ폜ďԂɕёւ
      CALL SETTIME(TIMEON,PCTIME,BCTIME,
     1          XRP, XEP, XH , XQ , NUMRAIN,          
     1          NUMEVAP,NIHT,NIQT,NUMTION,NUM2T) !
C
CCCCC      KK = 0
CCCCC      DO I=1,NBCTIME
CCCCC      TDUM = BCTIME(I)
CCCCC      IF(TDUM .GT. CEPS) THEN
CCCCC       KK = KK +1
CCCCC       TIMEON(KK) = BCTIME(I)
CCCCC      END IF
CCCCC      END DO
C
CCCCC      KKO = KK
CCCCC      DO I=1,MATCTIME       
CCCCC      TDUM = PCTIME(I)  
CCCCC      IF(TDUM .GT. CEPS) THEN
CCCCC       DO J=1,KKO
CCCCC       IF(ABS(TDUM - TIMEON(J)) .LE. CEPS) GO TO 811 !ԂȂsv
CCCCC       END DO
C!@@@@@@@Eɂ݂͑ȂԂۑ
CCCCC       KK = KK + 1
CCCCC       TIMEON(KK) = TDUM
CCCCC  811 CONTINUE
CCCCC      END IF
CCCCC      END DO
CCCCC      NUMTION=KK
C! f[^̃\[g
CCCCC      DO I=1,NUMTION-1
CCCCC      DUMT = TIMEON(I)
CCCCC      DO J=I+1,NUMTION
CCCCC      IF(DUMT .GT. TIMEON(J)) THEN
CCCCC       TIMEON(I) = TIMEON(J)
CCCCC       TIMEON(J) = DUMT
CCCCC       DUMT = TIMEON(I)
CCCCC      END IF
CCCCC      END DO
CCCCC      END DO
C
C-----------------------------------
C
      EPSLON=0.0D00
      NTIM = 0
C
C-------------------------------------------- SETUP FOR TIME INTEGERATION
C
C     vZ̏
      LAP = 0
   30 LA = 0
      TIME = 0.D00
      IF( NTYPE .LT. 0) THEN
C     vZ̏
       LA = 1
       TIME=DT
      END IF
   51 QTOT=0.0D00
      LAA=0
      ITER = 0
C                          <-------------------- NEXT TIME STEP
   60 CONTINUE
C
      IF(LAA .LT. 1) GO TO 2190
C@   !`̃f[^A
      IF( INCOR .NE. 1) THEN 
        REWIND 3         !t@Cgp
        READ (3) P,P1,Q,KODE,MATP,QINIT
        READ (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
        READ (3) IERAIN,ICAPA,IEVAP,CAPA
      ELSE
        REWIND 3         !gp
        READ (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
        READ (3) IERAIN,ICAPA,IEVAP,CAPA
 1000   DO 1020 I=1,NUMNP
        P(I)=PD3(I)
        P1(I)=PD13(I)
        Q(I)=QD3(I)
        KODE(I)=KODE3(I)
        QINIT(I)=QINIT3(I)
 1020 CONTINUE
      DO I=1,NUMEL
       MATP(I) = MATP3(I)
      END DO
      END IF
 2190 CONTINUE
C
C --------------------------ADD IMAI@IGEOL ---------------
C
      IF(ITSW .EQ. 0) THEN
      TI=TIME-DT*0.5D00
      ELSE
      TI=TIME 
      END IF
      IF(LA .EQ. 0) TI =0.0D0
C
      IF(NBCTIME .GE. 1 .AND. LA .GE. 1 ) THEN
C@E̕ύX
       DO M=1,NBCTIME
       TDUM = BCTIME(M)
C@ύXԂzύX
       IF(TDUM .GT. TIME-DT-CEPS2 .AND. TDUM .LE. TIME - CEPS2) THEN
C@e̕ύXݒ
        CALL NEWBC(NODE,X,Y,ITYPE,NUMNP,MXNODS,NUMEL,
     1  KODE,P,Q,QINIT,NSP,NP,MAXSP,NDIM,
     1  NRAINP,CAPA,ICAPA,IEVAP,XRP,YRP,XEP,YEP,IERAIN,
     2  NUMRAIN,NUMEVAP,NBN,NBOU,NBNQ,NBOUQ,BCTIME,NBCHTNN,
     3  NBCHTND,NBCHTSW,NBCHTP,NBCQTNN,NBCQTND,NBCQTSW,
     4  NBCQTP,NBCNN,HEADNBC,NBCCQ,QNBC,NBCND,NBCKCON,NBCCH,
     5  NBCRNN,NBCRND,NBCRSW,NBCRRP,NBCREP,NBCRMEN,CAPANBCR,M)
       END IF
       END DO
      END IF
C
      IF(MATCTIME .GE. 1 .AND. LA .GE. 1) THEN
C@ގ̕ύX
       DO M=1,MATCTIME
       TDUM = PCTIME(M)
C@ύXԂzύX
       IF(TDUM .GT. TIME-DT-CEPS2 .AND. TDUM .LE. TIME -CEPS2) THEN
         NLOP = MATCNM(M)  !ύX鑍ގ
         IF(NLOP .GT. 0) THEN
         DO I=1, NLOP
          IEDUM =  MATCM(M,I)   !ύXގԍ̎o
          IF(IEDUM .GT.0 ) THEN
           DO J=1,NUMEL     !ގԍvfočގύX
             IF(MATP(J) .EQ. IEDUM) MATP(J ) = MATCMM(M,I)
           END DO
          END IF
         END DO
         END IF
C
         NLOP = MATCNE(M)  !ύX鑍vf
         IF(NLOP .GT. 0) THEN
         DO I=1, NLOP
          IEDUM = MATCE(M,I)   !ύXvfԍ̎o
          IF(IEDUM .GT.0 ) MATP(IEDUM ) = MATCEM(M,I) 
         END DO                !̗vf̍ގύX
         END IF
       END IF
       END DO
C
      END IF
C--------------------------------------- SET UP NEW BOUNDARY CONDITION
C ԂƐʂ̊֌W̐ݒ
      IF( NBOUN .LT. 1) GO TO 251
      DO M=1,NBOUN
C                          ݂̎Ԃ琅ʂԂŎoB
C       CALL INTERP ( XH,YH,TI,TP,NIHT(M),NBOUN1,M,MIHT1)
       CALL INTERP ( XH,YH,TIME,TP,NIHT(M),NBOUN1,M,MIHT1)
       NB1=NBN(M)    !ʕϓ^ߓ_̌
c		write(55,*) NB1,TI,TP
      IF(NB1 .GT. 0) THEN
       DO J=1,MNBN
        N=NBOU(M,J)    !ʕϓ^ߓ_ԍ
        IF(N .GT. 0) THEN
        IF(Z(N) .LE. TP) THEN    !ʂʕϓ^ߓ_ԍ
          P(N)=TP-Z(N)           !ZWႢꍇ́AŒɂȂB
          KODE(N)=1 !ʌŒ
        ELSE
          KODE(N)=-2 !ŒɂȂiZoʂ̏ꍇ̂ŁA-2ɐݒj
        END IF       !ZoʂŖꍇłAZoʂ͕ʃf[^ŏ
c	write(55,*) N,KODE(N),P(N),P(N)+Z(N)
        END IF       !Ă̂ŁAB
       END DO
      END IF
      END DO
  251 CONTINUE
C ԂƗʂ̊֌W̐ݒ
      IF( NQBOUN .LT. 1) GO TO 260
      DO M=1,NQBOUN
C                          ݂̎Ԃ痬ʂԂŎo
       CALL INTERP ( XQ,YQ,TI,QQQ,NIQT(M),NQBOUN1,M,MIQT1)
       NB1=NBNQ(M)    !ʕϓ^ߓ_̌
      IF(NB1 .GT.0) THEN
       DO J=1,MNQBN
        QDATA(M,J)=QQQ    !ʂzɕۑ
       END DO
      END IF
      END DO
  260 CONTINUE
C-----------------------------------------------------------------------
C ~J̐ݒ
      IF(NRAIN .EQ. 0) GO TO 2090
      DO 2100 I=1,NRAIN
      N=NRAINP(I)    !~J^ߓ_ԍ̎o
      IF(N .GT .0)THEN
      IF(KODE(N) .LE.  0) THEN    !ʌŒ苫EȊOɂ
      KODE(N) = -4                !~J̐ߓ_̏-4ɐݒ
      END IF
      END IF
 2100 CONTINUE
 2090 CONTINUE
C
C
C ------------------------------------------------------- RAIN & EVAP
C
      IF(NERAIN .EQ. 0) GO TO 2030
C
      DO 2060 I=1,NRAIN
       RRDUM(I) = .0          !~Jɂ闬ʂvZ邽߂Ƀ[NA
 2060 CONTINUE
C
      DO 2040 I=1,NERAIN
      NE = IERAIN(I,1)          !vfԍ̎o
      IF(NE .LE. 0) GO TO 2040
	IF(ISWE(NE) .EQ. 1) GO TO 2040 !gpȂvf͏Ȃ
	IF(MATP(NE) .LT. 0) GO TO 2040
      ACAPA = CAPA(I,1)          !Z\̎o
      AREA  = CAPA(I,2)          !ʐς̎o
      IP = ICAPA(I)              !~J̎ԕωp^[
      IE = IEVAP(I)              !U̎ԕωp^[
C
C   RAIN
C
      RRR = 0.0
      IF(IP .NE. 0) THEN
      IF(MRK.GT.0 .AND. MRP.GT. 0) THEN
C       ̎Ԃ̍~JxԂŎoB
       CALL INTERP (XRP,YRP,TI,RRR,NUMRAIN(IP),MRP1,IP,MRK1)
      END IF
C       vfŎ󂯂S~Jʂ̌vZ
      RRR = RRR * ACAPA * AREA
      END IF
C
C   EVAP
C
      EEE = 0.0
      IF(IE .NE. 0) THEN
      IF(MEK.GT.0 .AND. MEP.GT. 0) THEN
C       ̎Ԃ̏UԂŎoB
      CALL INTERP (XEP,YEP,TI,EEE,NUMEVAP(IE),MEP1,IE,MEK1)
      END IF
C       vfȂ̑SUʂ̌vZ
      EEE = EEE * AREA
      END IF
C
C      ~JlnՓ֐ZB
      QQQ = RRR - EEE
      LOP = IERAIN(I,2)
      IF(LOP .GT. 0) THEN     !ʂ\ߓ_Ŋ
      QQQ = QQQ / FLOAT(LOP)  !ߓ_Ƃ̗ʂvZ
      DO 2050 J=1,LOP
      II = IERAIN(I,J+3)  !~Jlߓ_ɂĉԖڂ
      IF(II .GT.0)  RRDUM(II) = RRDUM(II) + QQQ   !ʂĂ
 2050 CONTINUE
      END IF
C
 2040 CONTINUE
 2030 CONTINUE
C
C------------------------------------- PRINT HED-TITLE,TIME AND TIME STEP
C@ԃXebv̈
      WRITE(NPMT6,70) HED,TIME,LA
       WRITE (*,70) HED,TIME,LA
   70 FORMAT (/20X,20A4,/20X,6HTIME =1PE13.5,5X,11HTIME STEP =I4/)
C
      NTIM = 0
C
      IF(LAA .LT. 1) GO TO 90
C      IF( INCOR .NE. 1) THEN
C        REWIND 3
C        READ (3) P,P1,Q,KODE,MATP,QINIT
C        READ (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
C        READ (3) IERAIN,ICAPA,IEVAP,CAPA
C      ELSE
C        REWIND 3
C        READ (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
C        READ (3) IERAIN,ICAPA,IEVAP,CAPA
C 1000   DO 1020 I=1,NUMNP
C        P(I)=PD3(I)
C        P1(I)=PD13(I)
C        Q(I)=QD3(I)
C        KODE(I)=KODE3(I)
C        QINIT(I)=QINIT3(I)
C 1020 CONTINUE
C      DO I=1,NUMEL
C       MATP(I) = MATP3(I)
C      END DO
C      END IF
      WRITE(NPMT6,80) LAA
   80 FORMAT(//20X,6HRECUL=I5//)
      GO TO 100
C
   90 CONTINUE
C@   !`̃f[^̕ۑ
      IF( INCOR .NE. 1 ) THEN
        REWIND 3                 !t@Cgp
        WRITE (3) P,P1,Q,KODE,MATP,QINIT
        WRITE (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
        WRITE (3) IERAIN,ICAPA,IEVAP,CAPA 
      ELSE
        REWIND 3                !gp
        WRITE (3) NBOU,NBN,NBOUQ,NBNQ,NSP,NP
        WRITE (3) IERAIN,ICAPA,IEVAP,CAPA
 1030   DO 1040 I=1,NUMNP
        PD3(I)=P(I)
        PD13(I)=P1(I)
        QD3(I)=Q(I)
        KODE3(I)=KODE(I)
        QINIT3(I)=QINIT(I)
 1040 CONTINUE
      DO I=1,NUMEL
       MATP3(I) = MATP(I)
      END DO
      END IF
  100 CONTINUE
      EPSLN1=1.0D28              !덷̏
      EPSLN2=1.0D28
      EPSLON=1.0D28
C
C --------------------------ADD IMAI@IGEOL ---------------
C@@@@@~J◬ʕωɂ闬ʂ̔zւ̉Z
C          ʂ̐ݒij
      DO I=1,NUMNP
      Q(I) = QINIT(I)
      END DO
C
C          ~Jɂ闬ʂ̉Z
      IF(NRAIN .EQ. 0) GO TO 2080
      DO 2070 I=1,NRAIN
      N=NRAINP(I)  !ߓ_ԍ
      IF(N .EQ. 0) GO TO 2070
      IF(KODE(N) .EQ. -4) THEN
      Q(N) = Q(N) + RRDUM(I)
      END IF
 2070 CONTINUE
 2080 CONTINUE
C
C          ʕωɂ闬ʂ̉Z
      IF( NQBOUN .LT. 1) GO TO 262
      DO M=1,NQBOUN
       NB1=NBNQ(M)
      IF(NB1 .GT.0) THEN
       DO J=1,MNQBN
        N=NBOUQ(M,J)   !ߓ_ԍ
        IF(N .GT. 0) Q(N) = Q(N) +QDATA(M,J)
       END DO
      END IF
      END DO
  262 CONTINUE
C
C------------------------------------- GENERATE TERMS OF MATRIX EQUATION
C       <-------- NEXT ITERATION
  110 CONTINUE
      COMMT='--- IN RESET '
C 
      DO 911 I=1,NUMNP
  911 SD(I)=P(I)
C             }gbNX̍쐬
      CALL RESET (KODE,A,B,Q,SD,P1,PP,X,Y,Z,XYZ,NODE,MATP,MXNODS,B1,
     1               E,MXX,XK,YK,XP,YP,XC,YC,ISP,IS,
     1               AD2,BD2,ITYPE,ISWE,
     2               NUMNP,NUMNP1,NWK,NUMEL,NUMMAT,MK,MP,
     3               LA,DT,DT1,ITER,INTEG,NDM,
     3               NWKT,NMNPT)
C     WRITE(*,900) LAA,ITER
C 900 FORMAT(/' ***** SUBR. RESET  PASSING *****  RECAL =',I3,
C    1        '  ITERATION =',I3)
C
C-------- SOLVE BY PRECONDITIONED CONJUGATE GRADIENT METHOD ( P.C.G.M. )
C
C              PCG@ɂ}gbNX̉@
      CALL SOLVCG ( A,B,P,ISP,IS,C,PP,KODE,NKODE,SD,
     1                                NUMNP,NUMNP1,NWK,ITMAX)
C     WRITE(*,910) LAA,ITER
C 910 FORMAT(/' ***** SUBR. SOLVCG PASSING *****  RECAL =',I3,
C    1        '  ITERATION =',I3)
C
C--------------------------------------------- DETERMINE BOUNDARY FLUXES
C              Œ萅ߓ_iKODE>0)̗ʌvZ
      CALL FIXQ (A,B,KODE,Q,P,P1,ISP,IS,AD2,BD2,
     1           NUMNP,NUMNP1,NWK,LA,INTEG,NWKT,NMNPT)
C     WRITE(*,920) LAA,ITER
C 920 FORMAT(/' ***** SUBR. FIXQ   PASSING *****  RECAL =',I3,
C    1        '  ITERATION =',I3)
C
C------------------------------------------- ITERATE TO IMPROVE SOLUTION
C
      IF (MAXIT .LT. 1) GO TO 220
C
      ITER=ITER+1    !JԂ̉Z
C
C------------------------------------ MODIFY CONDITIONS ON SEEPAGE FACES
C@Zoʏ̃`FbNƏC
      IF (NSEEP .EQ. 0) GO TO 170
      DO 160 I=1,NSEEP
      ICHECK=0
      NS=NSP(I)
      IF(NS .GT. 0) THEN
      DO 150 J=1,NS
      N=NP(I,J)
      IF(N .GT. 0) THEN
      IF (KODE(N) .NE. -2) GO TO 130
      IF (P(N) .LT. 0.) ICHECK=1
      IF (ICHECK .GT. 0) GO TO 150
      KODE(N)=2
      P(N)=0.0D00
      GO TO 150
  130 IF (KODE(N) .NE. 2 ) GO TO 150
      IF (ICHECK  .GT. 0 ) GO TO 140
      IF ( Q(N) .LT. 0.0D00 ) GO TO 150
  140 KODE(N)=-2
      Q(N)=0.0D00
      ICHECK=1
      END IF
  150 CONTINUE
      END IF
  160 CONTINUE
C
  170 CONTINUE
C --------------------------ADD IMAI@IGEOL --------------
C ----------------------------------- MODIFY CONDITIONS OF RAIN
C@~J̃`FbNƏC
      IF(NRAIN .EQ. 0) GO TO 2000
      DO 2010 I=1,NRAIN
      N=NRAINP(I)
      IF(N .EQ. 0) GO TO 2010
      IF(KODE(N) .NE. -4) GO TO 2020
C UNSATURATED
      IF(P(N) .LT.  PL ) GO TO 2010
C UNSATURATED -> SATURATED
      KODE(N) =4
      P(N) = PL
      GO TO 2010
C
 2020 CONTINUE
      IF(KODE(N) .NE. 4 ) GO TO 2010
C SATURATED
      IF(Q(N) .LT. RRDUM(I)) GO TO 2010
C SATURATED -> UNSATURATED
      KODE(N) = -4
      Q(N) = RRDUM(I)
C
 2010 CONTINUE
 2000 CONTINUE
C
C
C-------------------------------------------------- TEST FOR CONVERGENCE
C
      IF (ITER .LE. 2) GO TO 200  !JԂvZŒ3s
C@ő덷̌vZi2Ǒʂ̓ǂݏoj
      IF( INCOR .NE. 1 ) THEN
        REWIND 4 !t@C̎gp
        READ (4) C
      ELSE
 1050   DO 1070 I=1,NUMNP    !̎gp
        C(I)=PD4(I)
 1070 CONTINUE
      END IF
 1060 EPSLON=0.0D00
      DO 180 I=1,NUMNP
      AA=DABS(P(I)-C(I))   !덷̌vZ
      IF (AA .GE. EPSLON) THEN
      EPSLON=AA
      NMAX=I
      END IF
  180 CONTINUE
C
C------------------------------------------------------- PRINT OF EPSLON
C@@@덷̈
      WRITE(NPMT6,190) ITER,EPSLON,NMAX
      WRITE (*,190)ITER,EPSLON,NMAX
  190 FORMAT (/49H MAXIMUM CHANGE IN PRESSURE HEAD DURING ITERATION,I3,
     1           4H WAS,1PE13.5,8H AT NODE,I6)
C
      IF(EPSLON .LE. TOL) GO TO 220  !
      IF(LA .LE. 0 .AND. ITER   .GT. MAXITO) GO TO 300 !JԂ
C        IF(LA .LE. 0 .AND. EPSLN2 .LE. EPSLON) GO TO 301 !픭U
      IF(LA .LE. 0) GO TO 200
      IF(ITER .GT. MAXIT .OR. EPSLN2 .LE. EPSLON) GO TO 210 
C@@@@@@@@@@@@@@@@@@@!JԂ܂͔U
  200 IF( INCOR .NE. 1 ) THEN   !̎vZpɌʂۑ
        REWIND 4  !t@Cgp
        WRITE (4) P
      ELSE
 1080  DO 1100 I=1,NUMNP  !gp
       PD4(I)=P(I)
 1100 CONTINUE
      END IF
C
 1090 EPSLN2=EPSLN1
      EPSLN1=EPSLON
      GO TO 110
  210 TIME=TIME-DT  !̏ꍇAԑ𔼌čČvZ
      DT=.5D00*DT
      TIME=TIME+DT
      ITER=0
      LAA=LAA+1
      IF( LAA .GE. NCUL) GO TO 270
      GO TO 60
C
C--------------------------------------------------------- PRINT RESULTS
C
  220 IF( LA .LE. 0 ) GO TO 245
      DO 230 N=1,NUMNP
      QTOT=QTOT+Q(N)*DT !^CXebvԂ̐x̌vZ
  230 CONTINUE
C
C-------------------------------- PRINT CUMULATIVE INFLOW INTO SYSTEM IS
C ^CXebvԂ̐ẍ
      WRITE(NPMT6,240) QTOT
  240 FORMAT (/// 35H CUMULATIVE INFLOW INTO SYSTEM IS =1PE13.5)
C
C----------------------------------- PRINT HEAD PRESSURE OF NODAL POINTS
C
  245 CONTINUE
C
      IF( LA .LE. 1 )  GO TO 550
      IF( TIME .GE. TMAX ) GO TO 550
      MDPRN=MOD(LA,NPRINT)
      IF( MDPRN .NE. 0 ) GO TO 500
  550 CALL PRINTO (Q,P,Z,ISWN,NUMNP)     !(,͐Aʁj̈
C      CALL VECTORS(A,X,Y,Z,P,NODE,MATP,XK,YK,XP,YP,ITYPE,
C     &                   NUMNP,NUMEL,MXNODS,NUMMAT,MK,MP,NWK)
C
  500 CONTINUE
C
      IF( LA .LE. 1 )  GO TO 551
      IF( TIME .GE. TMAX ) GO TO 551
      MDPLT=MOD(LA,NPLOT)
      IF( MDPLT .NE. 0 ) GO TO 501
  551 CONTINUE            !(xNgǰvZ
      CALL VECTORS(A,X,Y,Z,P,NODE,MATP,XK,YK,XP,YP,ITYPE,ISWE,
     &             NUMNP,NUMEL,MXNODS,NUMMAT,MK,MP,NWK)  
C
C--------------------------------------- WRITE PLOTTER DATA TO 15TH FILE
C @@@@ʂ̃t@Co
      CALL PLODAT (A,P,Q,KODE,NUMNP,NUMEL,NWK,LA,TIME,ISWE,ISWN )
C
C----------------------------------------------- PRINT MOISTURED CONTENT
C
C     CALL MOIST (NODE,P,P1,C,PP,MATP,XP,YP,NUMNP,NUMEL,
C    1                  MP,NUMMAT,MXNODS,ISWE,ISWN)
C
C
C-------------------------------------------------- SET UP NEW TIME STEP
C
  501 CONTINUE
      IF( NTYPE .GE. 1 ) GO TO 280      !vẐ݂̏ꍇAI
C     ̃^CXebv̎Ԑݒ
      LA=LA+1
      DT1=DT
C
      IF( MAXIT .LT. 1 ) GO TO 250
      IF (EPSLON .LE. TOL .OR.(ITER .LT. MAXIT.AND. EPSLON .LT. EPSLN2))
     1GO TO 250
      GO TO 400
  250 IF (DABS(TIME-TMAX) .LE. .001D00*DT) GO TO 280
      IF (DT .LT. DTMAX) DT=DMUL*DT
      IF (DT .GT. DTMAX) DT=DTMAX
      IF ((TIME+DT) .GT. TMAX .OR. DABS(TMAX-TIME-DT) .LT. .2D00*DT)
     1DT = TMAX - TIME
C
C@ ύXԂ傤ǂԃXebvʂ悤ɐݒ
C
C@ Ď̎ԃXebvɂȂ܂ł́AύXԂ̃|C^ړȂB
      IF(IKNOW .NE. 0) KNOW = KNOW + 1
      IKNOW = 0
      IF(KNOW .LE. NUMTION) THEN
      IF((TIME+DT) .GT. TIMEON(KNOW) .OR. 
     1          DABS(TIMEON(KNOW)-TIME-DT).LT. .2D00*DT) THEN
       DT = TIMEON(KNOW) - TIME
       IKNOW = 1
      END IF
      END IF
C
      TIME=TIME+DT
      ITER=0
      LAA=0
C
      GO TO 60
C
  300 WRITE(NPMT6,310)
C     WRITE(*,310)
  310 FORMAT(//'  *** ERROR IN INITIAL CONDITION (ITER > ITMAX) ***'//)
      GO TO 400
  301 WRITE(NPMT6,311)EPSLN2,EPSLON
C     WRITE(*,311) EPSLN2,EPSLON
  311 FORMAT(//'  *** ERROR IN INITIAL CONDITION (EPS2 > EPSLN) ***'/,
     1         ' EPSLN2 =',D15.7,5X,'EPSLON =',D15.7,//)
      GO TO 400
C
  270 WRITE(NPMT6,275)
C     WRITE (*,275)
  275 FORMAT(//' ***LAA .GE. NCUL*********************')
      GO TO 400
C
  280 WRITE(NPMT6,285)
  285 FORMAT(//' ******GET GOOD RESULT*******')
C----   RE-CALCULATE  STEADY CONDITION  ---------------------------
      IF( NTYPE .NE. -2 ) GO TO 410
      NTYPE=1
      GO TO  30
C------------------------------------------------------------------
  410 CONTINUE
  400 CONTINUE
C------------------------------------------------------------------
      RETURN
      END
      SUBROUTINE SEEFAC ( NP,NSP,NSEEP,NDIM,MAXSP )
C
C Zoʃf[^̓ǂݍ
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*5  INCHA,INCHAO
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION NSP(NDIM),NP(NDIM,MAXSP)
C
      IK = 0
        INCHAO = INCHA 
      READ (IFIL,11) INCHA,NUMD   !O[vE̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE."SEEP ")   WRITE(NPMT6,394) "SEEP ","E  "
  394 FORMAT(" ** ERROR ** ",A5," DATA -- Group ",A3)
   11 FORMAT(A5,I5)
      IF(NUMD .GT. 0) THEN
      DO 30 J=1,NUMD
      INCHAO = INCHA 
      READ (IFIL,10) INCHA,IS,IE,ID   !O[vEA̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE."SEEP ")   WRITE(NPMT6,394) "SEEP ","EA "
      IF(ID .EQ. 0) ID = 1
      IF(IE .EQ. 0) IE =IS
C ǂݍ݌`ύXȂ̂ŁA]̕ϐɃf[^
      DO 20 I=IS,IE,ID
      IK = IK + 1
      IF(IK .LE. NDIM) THEN
      NP(IK,1) = I 
      NSP(IK) = 1
      END IF
   20 CONTINUE
   30 CONTINUE
      END IF
   10 FORMAT(A5,3I7)
C
C      DO 20 I=1,NSEEP
C      READ (IFIL,10)NSP(I)
C   10 FORMAT (10I7)
C      NS=NSP(I)
C      IF(NS .GT. 0) THEN
C      READ (IFIL,10) (NP(I,J),J=1,NS)
C      END IF
C   20 CONTINUE
C
      RETURN
      END
      SUBROUTINE MATIN ( XK,YK,XP,YP,XC,YC,MK,MP,NUMMAT)
C
C@ގ̓ǂݍ݂Ɛݒ
C
      IMPLICIT REAL*8 (A-H,O-Z)
C     
      CHARACTER*5 INCHA,INCHAO
C
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     1XC(MP,NUMMAT),YC(MP,NUMMAT)
C
C----------------------------------- READ AND PRINT MATERIAL INFORMATION
C
      INCHAO = INCHA 
      READ(IFIL,10) INCHA,CONS1,CONS2   !O[vG̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE. "UNIT ") WRITE(NPMT6,21)
   21 FORMAT( " ** ERROR ** UNIT DATA -- Group G ")
   10 FORMAT (A5,2E10.3)
      WRITE(NPMT6,20) CONS1,CONS2
   20 FORMAT (///50H  UNITS ARE CONTROLED BY THE FOLLOWING CONSTANTS -//
     1 9H  CONS1 =1PE12.3,3X,7HCONS2 =1PE12.3////9H MATERIAL,7X,2HK1,
     2 13X,2HK2,13X,2HK3,10X,8HPOPOSITY,10X,2HSS/)
C
      DO 50 M=1,NUMMAT
      INCHAO = INCHA              !O[vH̓ǂݍ
C                          kxx  kyy   kzz    n     Ss
      READ(IFIL,32) INCHA,C1(M),C2(M),C3(M),POR(M),SS(M)
      IF(INCHA .EQ. "    ") INCHA = INCHAO 
      IF(INCHA .NE. "PROP") WRITE(NPMT6,22)
   22 FORMAT( " ** ERROR ** PROP DATA -- Group H ")
   32 FORMAT(A4,1X,5E10.3)
   30 FORMAT(8E10.3)
      WRITE(NPMT6,40) M,C1(M),C2(M),C3(M),POR(M),SS(M)
   40 FORMAT (I8,E17.5,4E15.5)
   50 CONTINUE
C
C
      DO 120 M=1,NUMMAT
      NUMKM=NUMK(M)
      NUMPM=NUMP(M)
C
      INCHAO = INCHA 
      READ(IFIL,31)  INCHA !O[vIJ̓ǂݍ
      IF(INCHA .NE. "UNSAT") WRITE(NPMT6,23)
   23 FORMAT( " ** ERROR ** UNSAT DATA -- Group I,J ")
   31 FORMAT(A5)     
      READ(IFIL,30) (XK(I,M),YK(I,M),I=1,NUMKM) !O[vI̓ǂݍ
      READ(IFIL,30) (XP(I,M),YP(I,M),I=1,NUMPM) !O[vJ̓ǂݍ
      DO 60 I=1,NUMPM
      YP(I,M)=-YP(I,M) !Ӂ|bӁb
   60 CONTINUE
C
C  @@@@@@@@@@@Ɓ|C@̌vZ
      NUMC(M)=NUMP(M)
      NUMCM=NUMC(M)
      DO 70 I=1,NUMCM-1
      AA    =.5*(XP(I,M)+XP(I+1,M))
      BB     =(XP(I+1,M)-XP(I,M))/(YP(I+1,M)-YP(I,M))
      XC(I,M)=AA
      YC(I,M)=BB
   70 CONTINUE
      XC(NUMCM,M)=XP(NUMP(M),M)
      YC(NUMCM,M)=0.0
C
      WRITE(NPMT6,80) M
   80 FORMAT (//68H TABLE OF RELATIVE CONDUCTIVITY VERSUS MOISTURE CONTE
     1NT FOR MATERIAL I3/5(2X,8HRELA-CON,4X,8HMOIS-CON,2X)/)
      WRITE(NPMT6,90) (YK(I,M),XK(I,M),I=1,NUMKM)
   90 FORMAT (10E12.4)
C
      WRITE(NPMT6,100) M
  100 FORMAT (//60H TABLE OF PRESSURE HEAD VERSUS MOISTURE CONTENT FOR M
     1ATERIAL I3/5(2X,8HPRES-HE ,4X,8HMOIS-CON,2X)/)
      WRITE(NPMT6,90) (YP(I,M),XP(I,M),I=1,NUMPM)
C
      WRITE(NPMT6,110) M
  110 FORMAT (//73H TABLE OF SPECIFIC MOISTURE CAPACITY VERSUS MOISTURE
     1CONTENT FOR MATERIAL I3/5(2X,8HSPECI-CA,4X,8HMOIS-CON,2X)/)
      WRITE(NPMT6,90) (YC(I,M),XC(I,M),I=1,NUMCM)
  120 CONTINUE
C
      RETURN
      END
      SUBROUTINE NPIN (KODE,Q,P,P1,X,Y,Z,QINIT,NUMNP,INIT,NERR,
     1                 INCON,INVAL)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C  
C@ߓ_̓ǂݍ
C
      CHARACTER*5  INCHA,INCHAO
      CHARACTER*40 NODEFILE
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON / NEFILE / INNEFIL,IFFORM
C
      DIMENSION X(NUMNP),Y(NUMNP),Z(NUMNP),QINIT(NUMNP),
     1           KODE(NUMNP),Q(NUMNP),P(NUMNP),P1(NUMNP)
C
      NERR=0
C
      WRITE(NPMT6,10)
   10 FORMAT (////24H NODAL POINT INFORMATION //10H  NODE NO.,6X,4HKODE,
     1 7X,3H-X-,12X,3H-Y-,12X,3H-Z-,11X,5H.PSI.,12X,1HQ/)
      NPR=0
      L=0
C
      IF(	INNEFIL .GE. 1) THEN
      INCHAO = INCHA
      READ(IFIL,44) INCHA,NODEFILE    !O[vK'̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
   44 FORMAT(A5,A40)
      IF(INCHA .NE. "NODE ") WRITE(NPMT6,41)
      IF( INNEFIL .GE. 2) THEN      !ǂݍ݃t@C̐ݒ
      OPEN (22,FILE=NODEFILE,STATUS='UNKNOWN',FORM='FORMATTED')
      IFILO = IFIL
      IFIL = 22
      ELSE
      IFILO = IFIL
      IFIL = 21
      END IF
      END IF
C
   20 CONTINUE
      L=L+1
C
      IF(IFFORM .EQ. 0) THEN
      INCHAO = INCHA          !O[vK̓ǂݍ(ŒtH[}bgj
      READ(IFIL,40) INCHA,N,KODE(N),X(N),Y(N),Z(N),P1(N),Q(N)
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
   40 FORMAT (A5,I7,I3,5E10.3,A1)
      IF(INCHA .NE. "NODE ") WRITE(NPMT6,41)
   41 FORMAT( " ** ERROR ** NODE  DATA -- Group K ")
      ELSE                   !O[vK̓ǂݍ(t[tH[}bgj
      READ(IFIL,*) INCHA,N,KODE(N),X(N),Y(N),Z(N),P1(N),Q(N)
      END IF
      QINIT(N) = Q(N)
      P1(N)=P1(N)-INIT*Z(N)         !@P1ɂ͈͐li[
C
      IF (N-L) 50,90,70
   50 WRITE(NPMT6,60) N
   60 FORMAT (20H ERROR IN NPIN AT N= I5)
      NERR=1
      RETURN
C
   70 DENO=N-L+1         !
      DX=(X(N)-X(NPR))/DENO
      DY=(Y(N)-Y(NPR))/DENO
      DZ=(Z(N)-Z(NPR))/DENO
      DP=(P1(N)-P1(NPR))/DENO
   80 X(L)=X(L-1)+DX
      Y(L)=Y(L-1)+DY
      Z(L)=Z(L-1)+DZ
      P1(L)=P1(L-1)+DP
      KODE(L)=KODE(L-1) !Oߓ_̕
      Q(L)=Q(L-1)
      QINIT(L)=Q(L)
      L=L+1
      IF (L .LT. N) GO TO 80
   90 NPR=N
      IF (L .LT. NUMNP) GO TO 20
C
      IF(	INNEFIL .GE. 1) THEN
      CLOSE(IFIL)
      IFIL = IFILO
      END IF
C
      IF(INCON .NE. 0)THEN
      DO 200 I=1,INCON
      INCHAO = INCHA 
      READ(IFIL,201) INCHA,NS1,NE1,ND1,KDUM !O[vKA̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE. "KODE ") WRITE(NPMT6,203)
  203 FORMAT(" ** ERROR ** KODE DATA -- Group KA ")
      IF(ND1 .EQ. 0) ND1=1
      IF(NE1 .EQ. 0) NE1=NS1
      DO 202 N=NS1,NE1,ND1
      KODE(N) = KDUM
  202 CONTINUE
  200 CONTINUE
  201 FORMAT(A5,3I7,I4)
      END IF
C
      IF(INVAL .NE. 0) THEN
      DO 210 I=1,INVAL
      INCHAO = INCHA 
      READ(IFIL,211) INCHA,NS1,NE1,ND1,IPH,DVAL    !O[vKB̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
      IF(INCHA .NE. "INIT ") WRITE(NPMT6,213)
  213 FORMAT(" ** ERROR ** INIT DATA -- Group KB ")
      IF(ND1 .EQ. 0) ND1=1
      IF(NE1 .EQ. 0) NE1=NS1
      DO 212 N=NS1,NE1,ND1
      IF(IPH .EQ. "H") THEN
      P1(N)=DVAL-Z(N)
      ELSEIF(IPH .EQ. "P") THEN
      P1(N)=DVAL
      ELSEIF(IPH .EQ. "Q") THEN
      Q(N)     = DVAL
      QINIT(N) = DVAL
      ELSE
      P1(N)=DVAL-INIT*Z(N)
      END IF
  212 CONTINUE
  210 CONTINUE
  211 FORMAT(A5,3I7,A1,F9.0)
c  211 FORMAT(A5,3I7,A1,F23.0)
      END IF
C
      I=0
C
      DO 110 N=1,NUMNP
      IF( NDPR.EQ.0) WRITE(NPMT6,100) N,KODE(N),X(N),Y(N),Z(N),
     1                                P1(N),Q(N)
  100 FORMAT (I8,I4,5E15.6)
      P(N)=P1(N)
  110 CONTINUE
C
      RETURN
      END
      SUBROUTINE MAFIL (MATP,NODE,ITYPE,NUMEL,MXNODS)
      IMPLICIT REAL*8 (A-H,O-Z)
C 
C vf\̓ǂݍ
C
      CHARACTER*5 INCHA,INCHAO
      CHARACTER*40 ELEMFILE
C
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON / NEFILE / INNEFIL,IFFORM
C
      DIMENSION MATP(NUMEL),NODE(MXNODS,NUMEL),ITYPE(NUMEL)
C
      WRITE(NPMT6,10)
   10 FORMAT(////20H ELEMENT INFORMATION/)
C
C---------------------------------------------- READ ELEMENT INFORMATION
C
      IELN=8
      WRITE(NPMT6,20)( I,I=1,IELN)
   20 FORMAT(///12H    M,  MTYP,2X,8('NODE',I1,3X)/)
      NUM=0
C
      IF(INNEFIL .GE. 1) THEN
      INCHAO = INCHA 
      READ(IFIL,44) INCHA,ELEMFILE  !O[vD'̓ǂݍ
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
   44 FORMAT(A5,A40)
      IF(INCHA .NE. "ELEM ") WRITE(NPMT6,41)
      OPEN (21,FILE=ELEMFILE,STATUS='UNKNOWN',FORM='FORMATTED')
      IFILO = IFIL            !ǂݍ݃t@C̐ݒ
      IFIL = 21
      END IF
C
      DO 70 N=1,NUMEL
      IF(NUM-N) 30,70,50
C
   30 CONTINUE
      IF(IFFORM .EQ. 0) THEN
      INCHAO = INCHA       !O[vD̓ǂݍ(ŒtH[}bgj
      READ(IFIL,40) INCHA,NUM,(NODE(I,NUM),I=1,8),IELD,MTYP,KG1
      IF(INCHA .EQ. "     ") INCHA = INCHAO 
   40 FORMAT(A5,9I7,2I3,I7)
      IF(INCHA .NE. "ELEM ") WRITE(NPMT6,41)
   41 FORMAT(" ** ERROR ** ELEM DATA -- Group D ")
      ELSE                !O[vD̓ǂݍ(t[tH[}bgj
      READ(IFIL,*) INCHA,NUM,(NODE(I,NUM),I=1,8),IELD,MTYP,KG1
      END IF
      IF(IELD .EQ. 0) IELD=8
      ITYPE(NUM) = IELD
      IF(MTYP .EQ. 0) MTYP=1
C
      IF( KG1 .EQ. 0) KG1=1
      MATP(NUM)=MTYP
C
      KK1=KG1
      IF(NUM .EQ. N) GO TO 70
C
C---------------------------------------------- SAVE ELEMENT INFORMATION
C                               
   50 DO 60 I=1,8
      NODE(I,N)=NODE(I,N-1)+KK1
   60 CONTINUE
      MATP(N)=MATP(N-1) !Ovf̍ގ̕
      ITYPE(N) = ITYPE(N-1)
   70 CONTINUE
C
      IF(INNEFIL .GE. 1) THEN
      IF(INNEFIL .GE. 2) CLOSE(IFIL)
      IFIL = IFILO
      END IF
C
C--------------------------------------------- PRINT ELEMENT INFORMATION
C
      IF( NDPR.EQ.1) GO TO 100
      DO 80 N=1,NUMEL
      WRITE(NPMT6,90) N,MATP(N),(NODE(I,N),I=1,8)
   80 CONTINUE
   90 FORMAT(1H ,I6,I5,4X,8(I6,4X))
  100 CONTINUE
      RETURN
      END
      SUBROUTINE COLHT (NODE,IS,RMMK,ITYPE,NUMNP,NUMNP1,NUMEL,
     1                  MXNODS,NWK)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C  1z}gbNXi[eʃ`FbN
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION NODE(MXNODS,NUMEL),IS(NUMNP1),ISQ(500),RMMK(2,NUMEL)
      DIMENSION ITYPE(NUMEL)
C
C@@@evf̍őŏߓ_ԍT[`
      DO 1000 I=1,NUMEL
       RMMK(1,I)=NODE(1,I)
       RMMK(2,I)=RMMK(1,I)
       DO 1010 J=2,ITYPE(I)
        IF( RMMK(1,I) .GT. NODE(J,I)) RMMK(1,I)=NODE(J,I)-1
        IF( RMMK(2,I) .LT. NODE(J,I)) RMMK(2,I)=NODE(J,I)+1
 1010 CONTINUE
 1000 CONTINUE
C
      IS(1) = 1
      DO 200 I=1,NUMNP
      ISQ(1) = I
      K = 1
      J = 1
  210 IF( J .GT. NUMEL ) GO TO 500
C
C@ߓ_ƂɕKvȊi[eʂ̌
       IF( RMMK(1,J) .LE. I .AND. RMMK(2,J) .GE. I) THEN
C
      DO 230 M=1,ITYPE(J)
      IF( NODE(M,J) .EQ. I ) GO TO 240
  230 CONTINUE
      GO TO 220
  240 DO 260 II=1,ITYPE(J)
      JJ = NODE(II,J)
      DO 270 L=1,K
      IF( ISQ(L) .EQ. JJ ) GO TO 260
  270 CONTINUE
      K = K + 1
      IF( K .GT. 500 ) GO TO 300
      ISQ(K) = JJ
  260 CONTINUE
      END IF
  220 J = J + 1
      GO TO 210
  500 CONTINUE
C  
      IS(I+1) = IS(I) + K
  200 CONTINUE
C
      NUM = NUMNP1
      NWK = IS(NUMNP1) - 1
      GO TO 400
C
  300 WRITE(NPMT6,310)J,JJ,(ISQ(I),I=1,27)
  310 FORMAT(//' ****** ERROR IN COLHT --- > RELATIONSHIP NODE NUMBER >
     127 AT ELEMENT NO. ',I6,3X,'ERROR NODAL POINT NO.',I6/
     2' ******* NODAL POINTS *******'/2(10I6/),7I6)
      STOP
C
  400 RETURN
      END
C
      SUBROUTINE ADRSK (NODE,IS,ISP,ITYPE,NUMNP,NUMNP1,NUMEL,MXNODS,NWK)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C  1z}gbNXi[̊eԒn̐ݒ
C  
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION NODE(MXNODS,NUMEL),ISP(NWK),IS(NUMNP1)
      DIMENSION IA(200),ITYPE(NUMEL)
C
      DO 550 I=1,NWK
  550 ISP(I)=0
C------------------------
      DO 500 I=1,NUMEL
      ILOP = ITYPE(I)
      DO 501 J=1,ILOP
  501   IA(J)=NODE(J,I)
       DO 510 J=1,ILOP
       JJ=IA(J)
       II=IS(JJ)
       II2=IS(JJ+1)-1
        ISP(II)=JJ
        DO 520 K=1,ILOP
        IF( K .NE. J ) THEN
         DO 530 LL=II+1,II2
          IF( ISP(LL) .EQ. 0 ) GO TO 800
          IF( ISP(LL) .EQ. IA(K)) GO TO 801
  530    CONTINUE
c          write(88,*) I,IA(K)
c          write(88,*) II+1,II2
c          DO   LL=II+1,II2
c	    write(88,*) ISP(LL)
c	    END DO
          STOP 9999
  800    ISP(LL)=IA(K)
  801   CONTINUE
        END IF
  520 CONTINUE
  510 CONTINUE
  500 CONTINUE
C----------------------------------------------------------------------
      DO 1000 I=1,NUMNP
      IS1=IS(I)+1
      I1=IS(I)
      I2=IS(I+1)-1
      NUM=I2-I1
       DO 1001 J=IS1,I2
 1001  IA(J-IS1+1)=ISP(J)
      CALL PCGSRT(IA,NUM,IERR)     !Ԓnݒ
       DO 1002 J=IS1,I2
 1002  ISP(J)=IA(J-IS1+1)          !S̔Ԓnݒ
 1000 CONTINUE
C
C     WRITE(6,600)
C 600 FORMAT(' --- IS ---- & ----- ISP -----')
C     DO 610 I=1,NUMNP
C     I1 = IS(I)
C     I2 = IS(I+1) - 1
C     WRITE(6,620) I1,(ISP(J),J=I1,I2)
C 620 FORMAT(16I7)
C 610 CONTINUE
C
C     STOP 1111
      RETURN
      END
      SUBROUTINE RESET (KODE,A,B,Q,P,P1,D,X,Y,Z,XYZ,NODE,MATP,MXNODS,
     1                  B1,E,MXX,XK,YK,XP,YP,XC,YC,ISP,IS,
     1                  AD2,BD2,ITYPE,ISWE,
     2                  NUMNP,NUMNP1,NWK,NUMEL,NUMMAT,MK,MP,
     3                  LA,DT,DT1,ITER,INTEG,NDM,
     3                  NWKT,NMNPT)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C 
C@}gbNX
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
	COMMON / NEGAE / IERSW 
C
      DIMENSION A(NWK),B(NUMNP),KODE(NUMNP),Q(NUMNP),P(NUMNP),
     1          P1(NUMNP),D(NUMNP),X(NUMNP),Y(NUMNP),Z(NUMNP),
     3          MATP(NUMEL),NODE(MXNODS,NUMEL),
     4          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     5          XC(MP,NUMMAT),YC(MP,NUMMAT),ISP(NWK),
     6          IS(NUMNP1),B1(NDM),XYZ(NDM),E(MXX),ITYPE(NUMEL)
      DIMENSION AD2(NWKT),BD2(NMNPT),ISWE(NUMEL)
C
C
      IF (LA.GT.1) DTT=.5D00*DT/DT1
C------------------------- INITIALIZATION AND EXTRAPOLATION OF P  VALUES
      DO 40 I=1,NUMNP 
      B(I)=0.D00 !
      D(I)=0.D00
      A(I)=0.D00
      IF(ITER .LE.0) THEN
        IF( LA.LE.1) PP=P1(I)
        IF( LA.GT.1) PP=P(I)+DTT*(P(I)-P1(I)) !O}ɂӁiK+1/2)
        P1(I)=P(I)
        IF (KODE(I) .LT. 1) P(I)=PP
      ELSE
   10   PP=.5D00*(P(I)+P1(I))                 !}ɂӁiK+1/2)
        IF (KODE(I) .LT. 1) P(I)=PP
      END IF
   40 CONTINUE
      DO 30  J=NUMNP1,NWK    !
      A(J)=0.D00
   30 CONTINUE
C
C
      ITERSW = 0
      DO 70 N=1, NUMEL
	IF(ISWE(N) .EQ. 1) GO TO 70  !@퓙ŎgpȂvf΂B
      M=MATP(N)
	IF(M .LT. 0) GO TO 70
      CMUL=CONS1*SS(M)/POR(M)
C 
        IELD = ITYPE(N)
       IELM=IELD
       IEL=IELD
       ND=3*IELD
       I2=0
       DO 60  I=1,IEL
        II=NODE(I,N)
        I2=I2+3
        XYZ(I2-2)=X(II) !W̊i[
        XYZ(I2-1)=Y(II)
   60   XYZ( I2 )=Z(II)
C
c        write( NPMT6,*) N
	IERSW = 0
        CALL ELEM (A,B,P,D,XYZ,NODE,B1,ISP,IS,XK,YK,XP,YP,XC,YC,
     1            E,IELM,
     1            CMUL,MXX,NDM,
     2            NUMNP,NUMNP1,NWK,NUMMAT,MK,MP,M,N,ND,MXNODS,NUMEL)
c	 IF(IERSW .EQ. 1) write( NPMT6 ,*) N
c	 IF(IERSW .EQ. 1)  ITERSW = 1
C
   70 CONTINUE
c	 IF(ITERSW .EQ. 1)   stop
C
      IF( INCOR .NE. 1 ) THEN
        REWIND 2     !ԍOɃ}gbNX̕ۑivZׁ̈j
        WRITE (2) A,B
      ELSE
 1000   DO 1020 I=NUMNP1,NWK
 1020   AD2(I)=A(I)
        DO 1030 I=1,NUMNP
        AD2(I)=A(I)
 1030   BD2(I)=B(I)
      END IF
C--------- CONPLETE CONSTRUCTION OF RHS VECTOR AND FORM EFFECTIVE MATRIX
 1010  PP=2.D00
       IPP=2
      IF (LA .LE. 1 .OR. INTEG .EQ. 1) THEN
       PP=1.D00
       IPP=1
      END IF
      IF( LA .LE. 0 ) THEN
       DO 610 I=1,NUMNP
  610  D(I)=0.0D00 !̎A䒙OɂB
       END IF
      DO 110 I=1,NUMNP
      II = IS(I)              !ԍ̓
      B(I)=PP*(CONS2*Q(I)-B(I)+D(I)*P1(I)/DT)
      IF (IPP .NE. 1 ) THEN
       II1 = IS(I+1) - 1
       DO 90 J=II,II1
       K = ISP(J)
       B (I)=B (I)-A(J)*P1(K)
   90 CONTINUE
      END IF
  100 A(II)=A(II)+PP*D(I)/DT
  110 CONTINUE
C
      RETURN
      END
      SUBROUTINE ELEM(A,B,P,D,XYZ,NODE,B1,ISP,IS,
     1                XK,YK,XP,YP,XC,YC,E,IELM,CMUL,MXX,NDM,
     2                NUMNP,NUMNP1,NWK,NUMMAT,MK,MP,M,N,ND,
     3                MXNODS,NUMEL)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C  evf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
      COMMON /AD2005/ ICALSW1
C
      DIMENSION A(NWK),B(NUMNP),P(NUMNP),D(NUMNP),
     1          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     2          XC(MP,NUMMAT),YC(MP,NUMMAT),
     3          NODE(MXNODS,NUMEL),ISP(NWK),IS(NUMNP1),
     4          B1(NDM),XYZ(NDM),E(MXX),COND(3,3)
C
C----------------------------------------- DETERMINE CONDUCTIVITY TENSOR
C
      COND(1,1)=C1(M)      !OaW
      COND(2,1)=0.0D00
      COND(3,1)=0.0D00
      COND(1,2)=0.0D00
      COND(2,2)=C2(M)
      COND(3,2)=0.0D00
      COND(1,3)=0.0D00
      COND(2,3)=0.0D00
      COND(3,3)=C3(M)
C
C----------------------------- DETERMINE UNSATURATED VARIABLES FOR NODES
      DO 20 IM=1,MXX
      E(IM)=0.0D00  !vf}gbNX̏
   20 CONTINUE
C
       WET=1.0D00
C--------------------------------------------------- LOOP ON SUBELEMENTS
C
      IF(ICALSW1 .EQ. 0) THEN   !ICALSW1=0]̎菇(ɐʂ𕽋ρj=1WvZĂ畽
       IF(IELM .EQ. 8) THEN
C @@@6ʑ̗vf̃}gbNX̍쐬
      CALL QUADS3A( A,B,D,NODE,B1,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,NWK,
     1             IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2             P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
      ELSEIF(IELM .EQ. 6) THEN
C @@@3pvf̃}gbNX̍쐬
      CALL QUADS2A( A,B,D,NODE,B1,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,NWK,
     1             IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2             P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
      END IF
      ELSE
      IF(IELM .EQ. 8) THEN
C @@@6ʑ̗vf̃}gbNX̍쐬
      CALL QUADS3( A,B,D,NODE,B1,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,NWK,
     1             IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2             P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
      ELSEIF(IELM .EQ. 6) THEN
C @@@3pvf̃}gbNX̍쐬
      CALL QUADS2( A,B,D,NODE,B1,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,NWK,
     1             IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2             P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
      END IF
      END IF
C
      RETURN
      END
      SUBROUTINE QUADS3 (A,BB,D,NODE,B,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,
     1                   NWK,IELM,CMUL, WET2,N,MXNODS,NUMEL,ISP,IS,
     2                   P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@6ʑ̗vf̗vf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
	COMMON / NEGAE / IERSW 
C
      DIMENSION A(NWK),BB(NUMNP),D(NUMNP),NODE(MXNODS,NUMEL),
     1          B(NDM),XYZ(NDM),E(IELM,IELM),ISP(NWK),
     2          IS(NUMNP1),XG(4,4),WGT(4,4),COND(3,3),COND1(3,3),H(8),
     3          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     4          XC(MP,NUMMAT),YC(MP,NUMMAT),P(NUMNP),WET(8)
C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
      DATA WGT / 2.000,             0.,             0.,             0.,
     1 1.0000000000000,1.0000000000000,             0.,             0.,
     2  .5555555555556, .8888888888889, .5555555555556,             0.,
     3  .3478548451375, .6521451548625, .6521451548625, .3478548451375/
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      DO 10 LX=1,NINT
      E1=XG(LX,NINT)     !KEXϕ̍W
      DO 10 LY=1,NINT
      E2=XG(LY,NINT)     !KEXϕ̍W
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ)    !KEXϕ̍W
      WT=WGT(LX,NINT)*WGT(LY,NINT)*WGT(LZ,NINTZ)   !KEXϕ̏d
C
      CALL DERIQ3(XYZ,B,DET,E1,E2,E3,H,NDM)  !Jacobian}gbNX̍쐬
c	IF(IERSW .EQ. 1) RETURN
C
      FAC1=WT*DET
      FAC=DSQRT(FAC1)
      DO 20 I=1,ND
   20 B(I)=FAC*B(I)
C
C-------------------- COMPUTE PRESSURE HEAD AT INTEGRATION POINT (R,S,T)
C
c      SCOD=0.D00
c      DO 30 I=1,IEL
c      II=NODE(I,N)
c      SCOD=SCOD+P(II)*H(I)  !vf̕ϐ
c   30 CONTINUE
c      CM=SCOD
C
C---------- BASED ON PRESSURE HEAD AT INTEGRATION POINT(CM), CONPUTE THE
C           PRESSURE HEAD DEPENDENT CONDUCTIVITIES AND SPECIFIC MOISTURE
C           CONTENT
C
c      CPEC=0.D00  !Oa
c      RPEK=1.D00
c      TIK22=POR(M)
c      IF( CM .LT. 0.D00 ) THEN
c      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP)  !sOa
c      CALL INTERP (XK,YK,TETA, RPEK,NUMK(M),NUMMAT,M,MK)
c      CALL INTERP (XC,YC,TETA,CPEC,NUMC(M),NUMMAT,M,MP)
c       WET=0.0D00
c       IF(RPEK .LE. 1.0D-20) RPEK=1.0D-20
c       IF(CPEC .LE. 0.0) CPEC=0.0
c      END IF
C
      SCOD=0.D00
      TIK22=POR(M)
      CPEC=0.D00 
	RPEK=0.D00
      DO 30 I=1,IEL
      II=NODE(I,N)
	CM = P(II)
      SCOD=SCOD+CM*H(I)  !vf̕ϐ
      IF( CM .LT. 0.D00 ) THEN
	WET(I) = 0.0
      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP)  !sOa
      CALL INTERP (XK,YK,TETA, ARPEK,NUMK(M),NUMMAT,M,MK)
      CALL INTERP (XC,YC,TETA,ACPEC,NUMC(M),NUMMAT,M,MP)
	ELSE
	WET(I) = 1.0
      ACPEC=0.D00  !Oa
      ARPEK=1.D00
	END IF
      CPEC=CPEC+ACPEC*H(I)
      RPEK=RPEK+ARPEK*H(I)
   30 CONTINUE
      CM=SCOD
C
       COND1(1,1)=COND(1,1)*RPEK  !W
       COND1(2,1)=COND(2,1)*RPEK
       COND1(3,1)=COND(3,1)*RPEK
       COND1(1,2)=COND(1,2)*RPEK
       COND1(2,2)=COND(2,2)*RPEK
       COND1(3,2)=COND(3,2)*RPEK
       COND1(1,3)=COND(1,3)*RPEK
       COND1(2,3)=COND(2,3)*RPEK
       COND1(3,3)=COND(3,3)*RPEK
C
  110 DO 50 II=1,IEL
      I=3*II
      I1=I-1
      I2=I-2
      DO 40 JJ=1,IEL
      J=3*JJ
      J1=J-1
      J2=J-2                            
      BB1=B( I2)*(COND1(1,1)*B(J2)+COND1(1,2)*B(J1)+COND1(1,3)*B(J))
      BB2=B( I1)*(COND1(2,1)*B(J2)+COND1(2,2)*B(J1)+COND1(2,3)*B(J))
      BB3=B( I )*(COND1(3,1)*B(J2)+COND1(3,2)*B(J1)+COND1(3,3)*B(J))
   40 E(II,JJ)=E(II,JJ)+(BB1+BB2+BB3)  ![A]}gbNX
      K2=NODE(II,N)
      BB4=COND1(1,3)*B(I2)+COND1(2,3)*B(I1)+COND1(3,3)*B(I)
      BB4=BB4*FAC
      BB(K2)=BB(K2)+BB4      ![B]}gbNX
      B1=0.D00
      B1=TIK22*CMUL*WET(II)
      AA=CPEC+B1
      AA=AA*FAC1
      D(K2)=D(K2)+AA*H(II)     ![F]}gbNX
   50 CONTINUE
   10 CONTINUE
C
C
C----------------------------- ADD ELEMENT CONTRIBUTION TO A(N,M) MATRIX
C      vf}gbNX̑S̃}gbNXւ̊i[
      CALL SETAM(IS,NODE,ISP,A,E,
     &                  NWK,NUMEL,NUMNP1,MXNODS,IELM,IEL,N)
      RETURN
      END
      SUBROUTINE QUADS2 (A,BB,D,NODE,B,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,
     1                   NWK,IELM,CMUL, WET2,N,MXNODS,NUMEL,ISP,IS,
     2                   P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@Opvf̗vf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
	COMMON / NEGAE / IERSW 
C
      DIMENSION A(NWK),BB(NUMNP),D(NUMNP),NODE(MXNODS,NUMEL),
     1          B(NDM),XYZ(NDM),E(IELM,IELM),ISP(NWK),
     2          IS(NUMNP1),XG(4,4),WGT(4,4),COND(3,3),COND1(3,3),H(8),
     3          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     4          XC(MP,NUMMAT),YC(MP,NUMMAT),P(NUMNP),WET(8)
C
      DIMENSION ALL1(3),ALL2(3,3),ALL4(3,7),
     1          ALW1(1),ALW2(3)  ,ALW4(7) 
C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
C
      DATA WGT / 2.000,             0.,             0.,             0.,
     1 1.0000000000000,1.0000000000000,             0.,             0.,
     2  .5555555555556, .8888888888889, .5555555555556,             0.,
     3  .3478548451375, .6521451548625, .6521451548625, .3478548451375/
C
      DATA ALL1/
     1 0.3333333333333,0.3333333333333,0.3333333333333/
C
      DATA ALL2/
     1 0.6666666666667,0.1666666666667,0.1666666666667,
     2 0.1666666666667,0.6666666666667,0.1666666666667,
     3 0.1666666666667,0.1666666666667,0.6666666666667/
C
      DATA ALL4/
     1 0.3333333333333,0.3333333333333,0.3333333333333,
     1 0.0597158717   ,0.4701420641   ,0.4701420641   ,
     2 0.4701420641   ,0.0597158717   ,0.4701420641   ,
     3 0.4701420641   ,0.4701420641   ,0.0597158717   ,
     4 0.7974269853   ,0.1012865073   ,0.1012865073   ,
     5 0.1012865073   ,0.7974269853   ,0.1012865073   ,
     6 0.1012865073   ,0.1012865073   ,0.7974269853   /
C
      DATA ALW1/  1.0   /
C
      DATA ALW2/
     1 0.3333333333333,0.3333333333333,0.3333333333333/
C
      DATA ALW4 /
     1 0.2250000000   ,0.1323941527   ,0.1323941527     ,
     2 0.1323941527   ,0.1259391805   ,0.1259391805     ,
     3 0.1259391805   /
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      NNINT = NINT
      IF(NINT .EQ. 2) NNINT = 3
      IF(NINT .EQ. 3) NNINT = 7
      IF(NINT .EQ. 4) NNINT = 7
C
      DO 10 LX=1,NNINT
C                                             NINT =1
      IF(NINT .NE. 1) GO TO 1
      AL1=ALL1(1)    !KEXϕ̍W
      AL2=ALL1(2)    !KEXϕ̍W
      AL3=ALL1(3)    !KEXϕ̍W
      ALWW=ALW1(1)/2. !KEXϕ̏d
      GO TO 9
    1 CONTINUE
C
C                                             NINT =2
      IF(NINT .NE. 2) GO TO 2
      AL1=ALL2(1,LX)
      AL2=ALL2(2,LX)
      AL3=ALL2(3,LX)
      ALWW=ALW2(LX)/2.
      GO TO 9
    2 CONTINUE
C
C                                             NINT =3
      IF(NINT .NE. 3) GO TO 3
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
      ALWW=ALW4(LX)/2.
      GO TO 9
    3 CONTINUE
C
C                                             NINT =4
      IF(NINT .NE. 4) GO TO 9
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
      ALWW=ALW4(LX)/2.
    9 CONTINUE
C
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ) !KEXϕ̍W
      WT=ALWW*WGT(LZ,NINTZ) !KEXϕ̏d
C
C @@@@@@@@Jacobian}gbNX̍쐬
      CALL DERIQ2(XYZ,B,DET,AL1,AL2,AL3,E3,H,NDM)
c	IF(IERSW .EQ. 1) RETURN
C
      FAC1=WT*DET
      FAC=DSQRT(FAC1)
      DO 20 I=1,ND
   20 B(I)=FAC*B(I)
C
C-------------------- COMPUTE PRESSURE HEAD AT INTEGRATION POINT (R,S,T)
C
c      SCOD=0.D00
c      DO 30 I=1,IEL
c      II=NODE(I,N)
c      SCOD=SCOD+P(II)*H(I) !vf̕ϐ
c   30 CONTINUE
c      CM=SCOD
C
C---------- BASED ON PRESSURE HEAD AT INTEGRATION POINT(CM), CONPUTE THE
C           PRESSURE HEAD DEPENDENT CONDUCTIVITIES AND SPECIFIC MOISTURE
C           CONTENT
C
c      CPEC=0.D00 !Oa
c      RPEK=1.D00
c      TIK22=POR(M)
c      IF( CM .LT. 0.D00 ) THEN
c      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP) !sOa
c      CALL INTERP (XK,YK,TETA, RPEK,NUMK(M),NUMMAT,M,MK)
c      CALL INTERP (XC,YC,TETA,CPEC,NUMC(M),NUMMAT,M,MP)
c       WET=0.0D00
c       IF(RPEC .LE. 1.0D-20) RPEC=1.0D-20
c       IF(CPEC .LE. 0.0) CPEC=0.0
c      END IF
c
      SCOD=0.D00
      TIK22=POR(M)
      CPEC=0.D00 
	RPEK=0.D00
      DO 30 I=1,IEL
      II=NODE(I,N)
	CM = P(II)
      SCOD=SCOD+CM*H(I)  !vf̕ϐ
      IF( CM .LT. 0.D00 ) THEN
	WET(I) = 0.0
      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP)  !sOa
      CALL INTERP (XK,YK,TETA, ARPEK,NUMK(M),NUMMAT,M,MK)
      CALL INTERP (XC,YC,TETA,ACPEC,NUMC(M),NUMMAT,M,MP)
	ELSE
	WET(I) = 1.0
      ACPEC=0.D00  !Oa
      ARPEK=1.D00
	END IF
      CPEC=CPEC+ACPEC*H(I)
      RPEK=RPEK+ARPEK*H(I)
   30 CONTINUE
      CM=SCOD
C
       COND1(1,1)=COND(1,1)*RPEK  !W
       COND1(2,1)=COND(2,1)*RPEK
       COND1(3,1)=COND(3,1)*RPEK
       COND1(1,2)=COND(1,2)*RPEK
       COND1(2,2)=COND(2,2)*RPEK
       COND1(3,2)=COND(3,2)*RPEK
       COND1(1,3)=COND(1,3)*RPEK
       COND1(2,3)=COND(2,3)*RPEK
       COND1(3,3)=COND(3,3)*RPEK
C
  110 DO 50 II=1,IEL
      I=3*II
      I1=I-1
      I2=I-2
      DO 40 JJ=1,IEL
      J=3*JJ
      J1=J-1
      J2=J-2
      BB1=B( I2)*(COND1(1,1)*B(J2)+COND1(1,2)*B(J1)+COND1(1,3)*B(J))
      BB2=B( I1)*(COND1(2,1)*B(J2)+COND1(2,2)*B(J1)+COND1(2,3)*B(J))
      BB3=B( I )*(COND1(3,1)*B(J2)+COND1(3,2)*B(J1)+COND1(3,3)*B(J))
   40 E(II,JJ)=E(II,JJ)+(BB1+BB2+BB3)  ![A]}gbNX
      K2=NODE(II,N)
      BB4=COND1(1,3)*B(I2)+COND1(2,3)*B(I1)+COND1(3,3)*B(I)
      BB4=BB4*FAC
      BB(K2)=BB(K2)+BB4     ![B]}gbNX
      B1=0.D00
      B1=TIK22*CMUL*WET(II)
      AA=CPEC+B1
      AA=AA*FAC1
      D(K2)=D(K2)+AA*H(II)   ![F]}gbNX
   50 CONTINUE
   10 CONTINUE
C
C----------------------------- ADD ELEMENT CONTRIBUTION TO A(N,M) MATRIX
C      vf}gbNX̑S̃}gbNXւ̊i[
      CALL SETAM(IS,NODE,ISP,A,E,
     &                  NWK,NUMEL,NUMNP1,MXNODS,IELM,IEL,N)
      RETURN
      END
      SUBROUTINE SETAM(IS,NODE,ISP,A,E,
     &                  NWK,NUMEL,NUMNP1,MXNODS,IELM,IEL,N)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C      vf}gbNX̑S̃}gbNXւ̊i[
C
      DIMENSION IS(NUMNP1),NODE(MXNODS,NUMEL),ISP(NWK),A(NWK),
     &          E(IELM,IELM)
   57 DO 70 J=1,IEL
      JJ = NODE(J,N)
      II = IS(JJ)
      II1 = IS(JJ+1) - 1
      DO 75 L=1,IEL
      KK = NODE(L,N)
      DO 60 K=II,II1
C 
      IF( KK .NE. ISP(K)) GO TO 60
      A(K) = A(K) + E(J,L)
      GO TO 75
   60 CONTINUE
   75 CONTINUE
   70 CONTINUE
C
      RETURN
      END
      SUBROUTINE DERIQ3  (XX,B,DET,R,S,T,H,NDM)
      IMPLICIT REAL*8 (A-H,O-Z)
C 
C@@@@6ʑ̗vfJacobian}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /THREED/ IELD,IEL
	COMMON / NEGAE / IERSW 
C
      DIMENSION XX(3,8),B(NDM)
      DIMENSION H(8 ),P(3,8 ),XJ(3,3),XJI(3,3)
C
C--------------- FIND INTERPOLATION FUNCTIONS AND THEIR DERIVATIVES
C                EVALUATE JACOBIAN MATRIX AT POINT (R,S,T)
C                COMPUTE DETERMINANT OF JACOBIAN MATRIX AT POINT (R,S,T)
C
      CALL FUNCT (R,S,T,H,P,XJ,DET,XX)
c	IF(IERSW .EQ. 1) RETURN
C
C------------------------------------ COMPUTE INVERSE OF JACOBIAN MATRIX
C
      DUM=1.0D00/DET
      XJI(1,1)=DUM*( XJ(2,2)*XJ(3,3) - XJ(2,3)*XJ(3,2))
      XJI(2,1)=DUM*(-XJ(2,1)*XJ(3,3) + XJ(2,3)*XJ(3,1))
      XJI(3,1)=DUM*( XJ(2,1)*XJ(3,2) - XJ(2,2)*XJ(3,1))
      XJI(1,2)=DUM*(-XJ(1,2)*XJ(3,3) + XJ(1,3)*XJ(3,2))
      XJI(2,2)=DUM*( XJ(1,1)*XJ(3,3) - XJ(1,3)*XJ(3,1))
      XJI(3,2)=DUM*(-XJ(1,1)*XJ(3,2) + XJ(1,2)*XJ(3,1))
      XJI(1,3)=DUM*( XJ(1,2)*XJ(2,3) - XJ(1,3)*XJ(2,2))
      XJI(2,3)=DUM*(-XJ(1,1)*XJ(2,3) + XJ(1,3)*XJ(2,1))
      XJI(3,3)=DUM*( XJ(1,1)*XJ(2,2) - XJ(1,2)*XJ(2,1))
C
C----------------------- EVALUATE B MATRIX IN GLOBAL (X,Y,Z) COORDINATES
C
      DO  30 K=1,IEL
      K2=K*3
      K21=K2-1
      K22=K2-2
C 
      B( K2)=0.0D00
      B(K21)=0.0D00
      B(K22)=0.0D00
C 
      B(K22)=B(K22) + XJI(1,1)*P(1,K)    !N/Xi
      B(K21)=B(K21) + XJI(2,1)*P(1,K)
      B(K2 )=B(K2 ) + XJI(3,1)*P(1,K)
      B(K22)=B(K22) + XJI(1,2)*P(2,K)
      B(K21)=B(K21) + XJI(2,2)*P(2,K)
      B(K2 )=B(K2 ) + XJI(3,2)*P(2,K)
      B(K22)=B(K22) + XJI(1,3)*P(3,K)
      B(K21)=B(K21) + XJI(2,3)*P(3,K)
      B(K2 )=B(K2 ) + XJI(3,3)*P(3,K)
   30 CONTINUE
C
      RETURN
      END
      SUBROUTINE FUNCT (R,S,T,H,P,XJ,DET,XX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                                                                   .
C .      TO FIND INTERPOLATION FUNCTIONS ( H )                        .
C .      AND DERIVATIVES ( P ) CORRESPONDING TO THE NODAL             .
C .      POINTS OF A CURVILINEAR ISOPARAMETRIC HEXAHEDRON             .
C .                                                                   .
C .      TO FIND JACOBIAN ( XJ ) AND ITS DETERMINANT ( DET )          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C
C 
C@@@@6ʑ̗vf̌`֐Ȃǂ̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /THREED/ IELD,IEL
	COMMON / NEGAE / IERSW 
C
      DIMENSION H(8),P(3,8),XJ(3,3),XX(3,8)
C
      RP=1.0D00 + R     
      SP=1.0D00 + S
      TP=1.0D00 + T
      RM=1.0D00 - R
      SM=1.0D00 - S
      TM=1.0D00 - T
C
C------------------------- INTERPOLATION FUNCTIONS AND THEIR DERIVATIVES
C
C---- 8-NODE BRICK -----
C
      H(1)=0.125D00*RP*SP*TP         ! N
      H(2)=0.125D00*RM*SP*TP
      H(3)=0.125D00*RM*SM*TP
      H(4)=0.125D00*RP*SM*TP
      H(5)=0.125D00*RP*SP*TM
      H(6)=0.125D00*RM*SP*TM
      H(7)=0.125D00*RM*SM*TM
      H(8)=0.125D00*RP*SM*TM
C
      P(1,1)= 0.125D00*SP*TP        !N/r1
      P(1,2)=-P(1,1)
      P(1,3)=-0.125D00*SM*TP
      P(1,4)=-P(1,3)
      P(1,5)= 0.125D00*SP*TM
      P(1,6)=-P(1,5)
      P(1,7)=-0.125D00*SM*TM
      P(1,8)=-P(1,7)
C
      P(2,1)= 0.125D00*RP*TP        !N/r2
      P(2,2)= 0.125D00*RM*TP
      P(2,3)=-P(2,2)
      P(2,4)=-P(2,1)
      P(2,5)= 0.125D00*RP*TM
      P(2,6)= 0.125D00*RM*TM
      P(2,7)=-P(2,6)
      P(2,8)=-P(2,5)
C
      P(3,1)= 0.125D00*RP*SP        !N/r3
      P(3,2)= 0.125D00*RM*SP
      P(3,3)= 0.125D00*RM*SM
      P(3,4)= 0.125D00*RP*SM
      P(3,5)=-P(3,1)
      P(3,6)=-P(3,2)
      P(3,7)=-P(3,3)
      P(3,8)=-P(3,4)
C
C----------------------------- EVALUATE JACOBIAN MATRIX AT POINT (R,S,T)
C
      DO 100 I=1,3
      DO 100 J=1,3
      DUM=0.0D00
      DO 90 K=1,IELD
   90 DUM=DUM + P(I,K)*XX(J,K)
  100 XJ(I,J)=DUM
C
C--------------- COMPUTE DETERMINANT OF JACOBIAN MATRIX AT POINT (R,S,T)
C
      DET = XJ(1,1)*XJ(2,2)*XJ(3,3)        ! |J|
     1    + XJ(1,2)*XJ(2,3)*XJ(3,1)
     2    + XJ(1,3)*XJ(2,1)*XJ(3,2)
     3    - XJ(1,3)*XJ(2,2)*XJ(3,1)
     4    - XJ(1,2)*XJ(2,1)*XJ(3,3)
     5    - XJ(1,1)*XJ(2,3)*XJ(3,2)
C 
c      IF (DET.LE. 1.0D-8 ) THEN
c       WRITE(NPMT6,2000) 
c	IERSW =1
C        STOP
c 2000 FORMAT (40H STOP  -  NEGATIVE OR ZERO DETERMINANT       )
C
c      END IF
  110 RETURN
      END
C
      SUBROUTINE DERIQ2  (XX,B,DET,AL1,AL2,AL3,T,H,NDM)
      IMPLICIT REAL*8 (A-H,O-Z)
C 
C@@@@OpvfJacobian}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /THREED/ IELD,IEL
	COMMON / NEGAE / IERSW 
C
      DIMENSION XX(3,8),B(NDM)
      DIMENSION H(8 ),P(3,8 ),XJ(3,3),XJI(3,3)
C
C--------------- FIND INTERPOLATION FUNCTIONS AND THEIR DERIVATIVES
C                EVALUATE JACOBIAN MATRIX AT POINT (R,S,T)
C                COMPUTE DETERMINANT OF JACOBIAN MATRIX AT POINT (R,S,T)
C
      CALL FUNCT2(AL1,AL2,AL3,T,H,P,XJ,DET,XX)
C	IF(IERSW .EQ. 1) RETURN
C
C------------------------------------ COMPUTE INVERSE OF JACOBIAN MATRIX
C
      DUM=1.0D00/DET
      XJI(1,1)=DUM*( XJ(2,2)*XJ(3,3) - XJ(2,3)*XJ(3,2))
      XJI(2,1)=DUM*(-XJ(2,1)*XJ(3,3) + XJ(2,3)*XJ(3,1))
      XJI(3,1)=DUM*( XJ(2,1)*XJ(3,2) - XJ(2,2)*XJ(3,1))
      XJI(1,2)=DUM*(-XJ(1,2)*XJ(3,3) + XJ(1,3)*XJ(3,2))
      XJI(2,2)=DUM*( XJ(1,1)*XJ(3,3) - XJ(1,3)*XJ(3,1))
      XJI(3,2)=DUM*(-XJ(1,1)*XJ(3,2) + XJ(1,2)*XJ(3,1))
      XJI(1,3)=DUM*( XJ(1,2)*XJ(2,3) - XJ(1,3)*XJ(2,2))
      XJI(2,3)=DUM*(-XJ(1,1)*XJ(2,3) + XJ(1,3)*XJ(2,1))
      XJI(3,3)=DUM*( XJ(1,1)*XJ(2,2) - XJ(1,2)*XJ(2,1))
C
C----------------------- EVALUATE B MATRIX IN GLOBAL (X,Y,Z) COORDINATES
C
      DO  30 K=1,IEL
      K2=K*3 
      K21=K2-1
      K22=K2-2
C
      B( K2)=0.0D00
      B(K21)=0.0D00
      B(K22)=0.0D00
C
      B(K22)=B(K22) + XJI(1,1)*P(1,K)    !N/Xi
      B(K21)=B(K21) + XJI(2,1)*P(1,K)
      B(K2 )=B(K2 ) + XJI(3,1)*P(1,K)
      B(K22)=B(K22) + XJI(1,2)*P(2,K)
      B(K21)=B(K21) + XJI(2,2)*P(2,K)
      B(K2 )=B(K2 ) + XJI(3,2)*P(2,K)
      B(K22)=B(K22) + XJI(1,3)*P(3,K)
      B(K21)=B(K21) + XJI(2,3)*P(3,K)
      B(K2 )=B(K2 ) + XJI(3,3)*P(3,K)
   30 CONTINUE
C
      RETURN
      END
      SUBROUTINE FUNCT2(AL1,AL2,AL3,T,H,P,XJ,DET,XX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C .                                                                   .
C .   P R O G R A M                                                   .
C .                                                                   .
C .      TO FIND INTERPOLATION FUNCTIONS ( H )                        .
C .      AND DERIVATIVES ( P ) CORRESPONDING TO THE NODAL             .
C .      POINTS OF A CURVILINEAR ISOPARAMETRIC HEXAHEDRON             .
C .                                                                   .
C .      TO FIND JACOBIAN ( XJ ) AND ITS DETERMINANT ( DET )          .
C .                                                                   .
C . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
C 
C@@@@Opvf̌`֐Ȃǂ̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /THREED/ IELD,IEL
	COMMON / NEGAE / IERSW 
C
      DIMENSION H(8),P(3,8),XJ(3,3),XX(3,8)
C
      TP=1.0D00 + T
      TM=1.0D00 - T
C
C------------------------- INTERPOLATION FUNCTIONS AND THEIR DERIVATIVES
C
C---- 6-NODE BRICK -----
C
      H(1)=0.5D0*AL1*TP         ! N
      H(2)=0.5D0*AL2*TP
      H(3)=0.5D0*AL3*TP
      H(4)=0.5D0*AL1*TM
      H(5)=0.5D0*AL2*TM
      H(6)=0.5D0*AL3*TM
      H(7)=0.0
      H(8)=0.0
C
      P(1,1)= 0.5D0*TP        !N/L1
      P(1,2)= 0.0
      P(1,3)= -0.5D0*TP
      P(1,4)= 0.5D0*TM
      P(1,5)= 0.0
      P(1,6)= -0.5D0*TM
      P(1,7)= 0.0
      P(1,8)= 0.0
C
      P(2,1)= 0.0        !N/L2
      P(2,2)= 0.5D0*TP
      P(2,3)= -0.5D0*TP
      P(2,4)= 0.0
      P(2,5)= 0.5D0*TM
      P(2,6)= -0.5D0*TM
      P(2,7)= 0.0
      P(2,8)= 0.0
C
      P(3,1)=  0.5D0*AL1        !N/r3
      P(3,2)=  0.5D0*AL2
      P(3,3)=  0.5D0*AL3
      P(3,4)= -0.5D0*AL1
      P(3,5)= -0.5D0*AL2
      P(3,6)= -0.5D0*AL3
      P(3,7)= 0.0
      P(3,8)= 0.0
C
C------------------------ EVALUATE JACOBIAN MATRIX AT POINT (L1,L2,L3,T)
C
      DO 100 I=1,3
      DO 100 J=1,3
      DUM=0.0D00
      DO 90 K=1,IELD
      DUM=DUM + P(I,K)*XX(J,K)
   90 CONTINUE
      XJ(I,J)=DUM
  100 CONTINUE
C
C---------- COMPUTE DETERMINANT OF JACOBIAN MATRIX AT POINT (L1,L2,L3,T)
C
      DET = XJ(1,1)*XJ(2,2)*XJ(3,3)        ! |J|
     1    + XJ(1,2)*XJ(2,3)*XJ(3,1)
     2    + XJ(1,3)*XJ(2,1)*XJ(3,2)
     3    - XJ(1,3)*XJ(2,2)*XJ(3,1)
     4    - XJ(1,2)*XJ(2,1)*XJ(3,3)
     5    - XJ(1,1)*XJ(2,3)*XJ(3,2)
C
C      IF (DET.LE. 1.0D-8 ) THEN
C       WRITE(NPMT6,2000)
c        STOP
C       IERSW = 1
C 2000 FORMAT (40H STOP  -  NEGATIVE OR ZERO DETERMINANT       )
C
C      END IF
  110 RETURN
      END
C
      SUBROUTINE SOLVCG (A,B,P,ISP,IS,R,PP,KODE,NKODE,SD,
     1                                NUMNP,NUMNP1,NWK,ITMAX )
      IMPLICIT REAL*8 (A-H,O-Z)
C
C@PCG@[`
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION A(NWK),B(NUMNP),P(NUMNP),ISP(NWK),SD(NUMNP),
     1 IS(NUMNP1),R(NUMNP),PP(NUMNP),KODE(NUMNP),NKODE(NUMNP)
C ---- ATOL -----
      ATOL  = 1.0D-60
      ATOL2 = ATOL*ATOL
      NUMKOD=0
       PMAX=0.0D00
C
      DO 5 I=1,NUMNP
      R(I) = 0.0D00
      PP(I) = 0.0D00
      II = IS(I)
       IF( DABS(A(II)).LE.ATOL ) A(II)=0.0D00
       SD(I)=A(II)
      IF( KODE(I) .LT. 1 ) THEN
C-----------------------
      NUMKOD=NUMKOD+1
      NKODE(NUMKOD)=I
C-----------------------
      II0=II+1
      II1 = IS(I+1) - 1
      S = SD(I)*P(ISP(II))
      DO 10 J=II0,II1
C
C----------------------------------------
      IF( DABS(A(J)) .LE. ATOL ) A(J)=0.0D00
C----------------------------------------
      S = S + A(J)*P(ISP(J))
   10 CONTINUE
      R(I) = B(I) - S
      PP(I) = R(I)/SD(I)
       PM=DABS(PP(I))
       IF( PM .GT. PMAX ) PMAX=PM
      END IF
    5 CONTINUE
C        WRITE(6,*)'  PMAX  ',PMAX
C
      IT = 1
   30 PR = 0.0D00
      PAP = 0.0D00
      DO 40 MM=1,NUMKOD
C
      I=NKODE(MM)
      II = IS(I)
      II1 = IS(I+1) - 1
      PPI=PP(I)
      PR = PR + PPI*R(I)
      BI = SD(I)*PP(ISP(II))
      II0=II+1
      DO 50 J=II0,II1
C
      BI = BI + A(J)*PP(ISP(J))
   50 CONTINUE
      PAP = PAP + PPI*BI
      B(I)=BI
   40 CONTINUE
      D = PR/PAP
C
      RAP = 0.0D00
      EPSX = 0.0D00
      DO 60 MM=1,NUMKOD
C-
      I=NKODE(MM)
      DELTAX = D*PP(I)
       PPI=P(I)
       PI=PPI
       RI=R(I)
       BI=B(I)
        PPI2=PPI*PPI
       IF(PPI2.LT.ATOL2) PPI=1.0D0
   52 DELTA = DELTAX/PPI
      DELTA = DELTA*DELTA
      EPSX = EPSX + DELTA
   54 PI = PI + DELTAX
      RI = RI - D*BI
C 
      RAP = RAP + (RI/SD(I))*BI
      P(I)=PI
      R(I)=RI
   60 CONTINUE
      IF( EPSX .LE. 1.0D-10) GO TO 80   !`FbN
      MLAP=MOD(IT,100)
      IF(MLAP.NE.0) GO TO 63
      WRITE(NPMT6,800)IT,EPSX
   63 IF( IT .GE. ITMAX ) GO TO 75
C 
   65 E = -RAP/PAP
      DO 70 MM=1,NUMKOD
C 
      I=NKODE(MM)
      PP(I) = R(I)/SD(I) + E*PP(I)
   70 CONTINUE
      IT = IT + 1
      GO TO 30
C
   75 WRITE(NPMT6,600) ITMAX
  600 FORMAT(' *** FAILURE TO CONVERGENCE IN SOLVER -- ITMAX =',I5)
      STOP 999
   80 WRITE(NPMT6,660) IT,EPSX
  660 FORMAT(' *** SUCCESS TO CONVERGENCE IN SOLVER -- IT =',I5,
     &       ' EPSX = ',E15.7)
  800 FORMAT(/'***SOLVCG CHK IT=',I6,' EPSX=',E15.7)
      RETURN
      END
      SUBROUTINE FIXQ(A,B,KODE,Q,P,P1,ISP,IS,AD2,BD2,
     1                NUMNP,NUMNP1,NWK,LA,INTEG,NWKT,NMNPT)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C  
C@Œߓ_ł̗ʌvZ
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
C
      DIMENSION A(NWK),B(NUMNP),KODE(NUMNP),Q(NUMNP),P(NUMNP),
     1          P1(NUMNP),ISP(NWK),IS(NUMNP1)
      DIMENSION AD2(NWKT),BD2(NMNPT)
C
      IF( INCOR .NE. 1 ) THEN
        REWIND 2  !}gbNXA,B̕A
        READ (2) A,B
      ELSE
 1000   DO 1020 I=NUMNP1,NWK
 1020   A(I)=AD2(I)
        DO 1030 I=1,NUMNP
        A(I)=AD2(I)
 1030   B(I)=BD2(I)
      END IF
 1010 PPP=1.0D00
      PP=2.0D00
      IF (LA .NE. 1 .AND. INTEG .NE. 1) GO TO 10
      PPP=0.0D00
      PP=1.0D00
C
   10 DO 40 N=1,NUMNP
      IF (KODE(N) .GE.1) THEN
      II = IS(N)
      II1 = IS(N+1) - 1
      Q(N) = PP*B(N)
      DO 30 M=II,II1
      K = ISP(M)
      Q(N)=Q(N)+A(M)*(P(K)+P1(K)*PPP)
   30 CONTINUE
      Q(N)=Q(N)/(CONS2*PP)
      END IF
   40 CONTINUE
C
      RETURN
      END
C-----------
      SUBROUTINE PRINTO (Q,P,Z,ISWN,NUMNP)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C@ʏóiS,͐,ʁj
C 
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION Q(NUMNP),P(NUMNP),Z(NUMNP),ISWN(NUMNP),
     1          NN(3),PP(3),HH(3),QQ(3)
C
      WRITE(NPMT6,10)
C
   10 FORMAT (////1X,3(43H NODE    HEAD       PRESS HEAD   DISCHARGE )
     1//)
C
      QM=0.0
      QP=0.0
C
      J=0
      N=0
   20 CONTINUE
      N=N+1
      IF (N .GT. NUMNP) GO TO 30
      IF(ISWN(N) .EQ. 1) GO TO 20
      J=J+1
      NN(J)=N
      PP(J)=P(N)
      HH(J)=PP(J)
      HH(J)=HH(J)+Z(N)
      QQ(J)=Q(N)
C
      IF( Q(N) .GT. 0.0 ) QP=QP+Q(N)
      IF( Q(N) .LT. 0.0 ) QM=QM+Q(N)
C
      GO TO 40
   30 J=J+1
      NN(J)=0
      PP(J)=0.
      HH(J)=0.
      QQ(J)=0.
   40 IF (J .LT. 3) GO TO 20
C
      WRITE(NPMT6,50) (NN(J),HH(J),PP(J),QQ(J),J=1,3)
   50 FORMAT (1X,3(I6,1P3E12.4))
C
      J=0
      IF (N .LT. NUMNP) GO TO 20
C-------------
      WRITE (NPMT6,2100) QP,QM   !ʂ̑ai{A|j
 2100 FORMAT(//'***   QP( +  ) =',1PE13.5/
     1         '***   QM( -  ) =',1PE13.5 )
C
      RETURN
      END
C------------------
      SUBROUTINE MOIST (NODE,P,P1,T,T1,MATP,XP,YP,NUMNP,NUMEL,
     1                  MP,NUMMAT,MXNODS,ISWE,ISWN)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C 
C@̐ϊܐ̌vZ@(ғj
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
C
      DIMENSION NODE(MXNODS,NUMEL),MATP(NUMEL),ISWE(NUMEL),
     1          P(NUMNP),P1(NUMNP),ISWN(NUMNP),
     2          T(NUMNP),T1(NUMNP),XP(MP,NUMMAT),YP(MP,NUMMAT),
     3          NN(6),TT(6)
C
      DO 130 M=1,NUMMAT
      DO  10 I=1,NUMNP
      T(I)=-1.0D00
   10 CONTINUE
C
      DO 60 N=1,NUMEL
	IF(ISWE(N) .EQ. 1) GO TO 60
	IF(MATP(N) .LT. 0) GO TO 60
      IF(MATP(N) .NE. M ) GO TO 60
      IEP=8
C
      DO 50  J=1,IEP
      I=NODE(J,N)
      IF( T(I) .GT. 0.D00) GO TO 50
      IF( P1(I) .LT. 0.D00) GO TO 20
      T1(I)=POR(M)
      GO TO 30
   20 CALL INTERP (YP,XP,P1(I),T1(I),NUMP(M),NUMMAT,M,MP)
   30 IF (P(I) .LT. 0.D00) GO TO 40
      T(I)=POR(M)
      GO TO 50
C
   40 CALL INTERP (YP,XP,P(I),T(I),NUMP(M),NUMMAT,M,MP)
C
   50 CONTINUE
   60 CONTINUE
      WRITE(NPMT6,70) M
   70 FORMAT (///64H MOISTUREDCONTENT AT UNSATURATED NODES CORRESPONDING
     1 TO MATERIAL,I3/)
      J=0
      N=0
   80 DO 90 K=1,6
      NN(K)=0
      TT(K)=0.D00
   90 CONTINUE
  100 CONTINUE
      N=N+1
      IF (N .GT. NUMNP) GO TO 110
	IF(ISWN(N) .EQ .1) GO TO 100
      IF (T(N) .EQ. POR(M) .OR. T(N) .LT. 0.D00) GO TO 100
      J=J+1
      NN(J)=N
      TT(J)=T(N)
      IF (J .LT. 6) GO TO 100
  110 WRITE(NPMT6,120)(NN(K),TT(K),K=1,6)
  120 FORMAT (6(I7,E13.5))
      J=0
      IF (N .LT. NUMNP) GO TO 80
  130 CONTINUE
C
      RETURN
      END
      SUBROUTINE INTERP (X,Y,XX,YY,N,M,J,K)
C
C@}[`
C
      IMPLICIT REAL*8 (A-H,O-Z)
C 
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
C
      DIMENSION X(K,M),Y(K,M)
C
C---- LINEAR INTERPOLATION
        YY=Y(N,J)
        IF( XX .LT. X(N,J)) THEN
      DO 10 I=2,N
      IF (XX .GT. X(I,J)) GO TO 10
        I1=I-1
      YY=Y(I1,J)+(XX-X(I1,J))*(Y(I,J)-Y(I1,J))/(X(I,J)-X(I1,J))
      GO TO 20
   10 CONTINUE
C
      END IF
   20 RETURN
      END
      SUBROUTINE MESCHK ( NODE,KODE,X,Y,Z,P,Q,MATP,
     &                   HED,NUMNP,NUMEL,MXNODS )
      IMPLICIT REAL*8 ( A-H,O-Z )
C
C@􉽌`̃t@CóiX,Y,Z,P,Q,KODEAvf\j
C
      REAL*4 HED
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
C     ***********************************************************
C     *     THIS IS SUBROUTINE TO MEMORY MESH CHECK DATA        *
C     ***********************************************************
      DIMENSION X(NUMNP),Y(NUMNP),Z(NUMNP),P(NUMNP), MATP(NUMEL),
     &          NODE(MXNODS,NUMEL),HED(20),KODE(NUMNP),Q(NUMNP)
C
      REWIND NOTAPP
      REWIND NOTAPR
      IF( ITAP .EQ. 0 ) THEN
       WRITE(NOTAPR,*) HED,NUMNP,NUMEL,MXNODS
       WRITE(NOTAPP,'(20a4)') HED
       WRITE(NOTAPP,*) NUMNP,NUMEL,MXNODS
       WRITE(NOTAPP,*)(X(I),Y(I),Z(I),P(I),Q(I),KODE(I),I=1,NUMNP)
       WRITE(NOTAPP,*)((NODE(I,J),I=1,MXNODS),MATP(J),J=1,NUMEL)
      ELSE
       WRITE(NOTAPP) HED,NUMNP,NUMEL
       WRITE(NOTAPR) HED,NUMNP,NUMEL
       WRITE(NOTAPP) X,Y,Z,KODE,P,Q
       WRITE(NOTAPP) NODE
      ENDIF
   10 FORMAT(20A4,2I5)
   20 FORMAT(3E15.7)
   30 FORMAT(8I5)
C
      RETURN
      END
      SUBROUTINE PLODAT ( A,P,Q,KODE,NUMNP,
     1                    NUMEL,NWK,LA,TIME ,ISWE,ISWN)
      IMPLICIT REAL*8 ( A-H,O-Z )
C
C@vZʂ̃t@CóiP,Q,Vx,Vy,Vz,KODE)
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
C     ***********************************************************
C     *     THIS IS SUBROUTINE TO MEMORY PLOTTER DATA           *
C     ***********************************************************
C
      DIMENSION P(NUMNP),KODE(NUMNP),Q(NUMNP),A(NWK)
	DIMENSION ISWE(NUMEL),ISWN(NUMNP)
C
  200 CONTINUE
      IF( ITAP .EQ. 0 ) THEN
       WRITE(NOTAPP,*) LA,TIME
       WRITE(NOTAPP,*)(P(I),Q(I),KODE(I),I=1,NUMNP)
       WRITE(NOTAPP,*)(A(I*3-2),A(I*3-1),A(I*3),I=1,NUMEL)
      ELSE
       WRITE(NOTAPP) LA,TIME
       WRITE(NOTAPP) P
      END IF
   10 FORMAT(20A4,5I5,E15.7)
   20 FORMAT(3E15.7)
   30 FORMAT(8I5)
   40 FORMAT(I5,E15.7,I5)
      RETURN
      END
      SUBROUTINE PCGSRT(IA,NUM,IERR)
      DIMENSION IA(NUM)
      IF(NUM .GE.2) THEN
   10 IERR=0
      DO 20 I=2,NUM
        DO 30 J=1,I-1
         JJ=J
      IF( IA(I) .LT. IA(J)) GO TO 40
   30 CONTINUE
      GO TO 20
   40 IAA=IA(I)
      K=I
      DO 60 KK=JJ,I-1
       K=K-1
      IA(K+1)=IA(K)
   60 CONTINUE
       IA(JJ)=IAA
   20 CONTINUE
      ELSE
       IERR=-1
      END IF
 9999 RETURN
      END
      SUBROUTINE VECTORS(A,X,Y,Z,P,NODE,MATP,XK,YK,XP,YP,ITYPE,ISWE,
     &                   NUMNP,NUMEL,MXNODS,NUMMAT,MK,MP,NWK)
      IMPLICIT REAL*8( A-H, O-Z)
C
C@xNǧvZ
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/ IELD,IEL
C
      DIMENSION P(NUMNP),X(NUMNP),Y(NUMNP),Z(NUMNP),MATP(NUMEL),
     &          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     &          NODE(MXNODS,NUMEL),COND(3,3),XX(3,8),B(24),H(8),PH(8),
     &          A(NWK),ITYPE(NUMEL),ISWE(NUMEL)
C
      DO I=1,NUMEL
	IF(ISWE(I) .EQ. 1) GO TO 100
        M=MATP(I)
	IF(M .LT. 0) GO TO 100
        PM=0.0
        IEL=ITYPE(I)
        IELD=IEL
        NDM=3*IEL
        DO J=1,IEL
         K=NODE(J,I)
         XX(1,J)=X(K)
         XX(2,J)=Y(K)
         XX(3,J)=Z(K)
      PH(J)=P(K)+Z(K)
      PM=PM+P(K)*0.125
      END DO
      RPEK=1.0
      TETA=POR(M)
      IF( PM .LT. 0.0 ) THEN
      CALL INTERP (YP,XP,PM,TETA,NUMP(M),NUMMAT,M,MP)
      CALL INTERP (XK,YK,TETA, RPEK,NUMK(M),NUMMAT,M,MK)
      IF(RPEK .LT. 0.0 ) RPEK=0.0
      END IF
C--------------------DARCY VELOCITY TETA=1.0
C--------------------REAL  VELOCITY TETA IS FROM SUB.INTERP
      TETA=1.0
C-------------------   
      RPEK=RPEK/TETA
      IF(IEL .EQ. 8)THEN
      R=0.0
      S=0.0
      T=0.0
      CALL DERIQ3(XX,B,DET,R,S,T,H,NDM)
      ELSEIF(IEL .EQ. 6) THEN
      AL1=1.0/3.0
      AL2=1.0/3.0
      AL3=1.0/3.0
      T=0.0
      CALL DERIQ2(XX,B,DET,AL1,AL2,AL3,T,H,NDM)
      END IF
C      WRITE(*,*)('H',H(M),M=1,8) 
      COND(1,1)=C1(M)*RPEK
      COND(2,1)=  0.0*RPEK
      COND(3,1)=  0.0*RPEK
      COND(1,2)=  0.0*RPEK
      COND(2,2)=C2(M)*RPEK
      COND(3,2)=  0.0*RPEK
      COND(1,3)=  0.0*RPEK
      COND(2,3)=  0.0*RPEK
      COND(3,3)=C3(M)*RPEK
      DHX=0.0
      DHY=0.0
      DHZ=0.0
      DO JJ=1,IEL
      J=3*JJ
      J1=J-1
      J2=J-2
      DHX=DHX+B(J2)*PH(JJ)
      DHY=DHY+B(J1)*PH(JJ)
      DHZ=DHZ+B(J) *PH(JJ)
      END DO
        VX=COND(1,1)*DHX +COND(1,2)*DHY +COND(1,3)*DHZ
        VY=COND(2,1)*DHX +COND(2,2)*DHY +COND(2,3)*DHZ
        VZ=COND(3,1)*DHX +COND(3,2)*DHY +COND(3,3)*DHZ
          A(I*3-2)=-VX
          A(I*3-1)=-VY
          A(I*3  )=-VZ
C      WRITE(*,1000)I,DHX,DHY,DHZ
C      WRITE(*,1001)I,VX,VY,VZ
C 1001 FORMAT('  N-ELM=',I7,' V=',3E15.7)
C 1000 FORMAT('  N-ELM=',I7,'DH=',3E15.7)
 100   CONTINUE
        END DO
       RETURN
       END
C
      SUBROUTINE QUADS3A (A,BB,D,NODE,B,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,
     1                   NWK,IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2                   P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@6ʑ̗vf̗vf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
	COMMON / NEGAE / IERSW 
C
      DIMENSION A(NWK),BB(NUMNP),D(NUMNP),NODE(MXNODS,NUMEL),
     1          B(NDM),XYZ(NDM),E(IELM,IELM),ISP(NWK),
     2          IS(NUMNP1),XG(4,4),WGT(4,4),COND(3,3),COND1(3,3),H(8),
     3          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     4          XC(MP,NUMMAT),YC(MP,NUMMAT),P(NUMNP)
C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
      DATA WGT / 2.000,             0.,             0.,             0.,
     1 1.0000000000000,1.0000000000000,             0.,             0.,
     2  .5555555555556, .8888888888889, .5555555555556,             0.,
     3  .3478548451375, .6521451548625, .6521451548625, .3478548451375/
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      DO 10 LX=1,NINT
      E1=XG(LX,NINT)     !KEXϕ̍W
      DO 10 LY=1,NINT
      E2=XG(LY,NINT)     !KEXϕ̍W
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ)    !KEXϕ̍W
      WT=WGT(LX,NINT)*WGT(LY,NINT)*WGT(LZ,NINTZ)   !KEXϕ̏d
C
      CALL DERIQ3(XYZ,B,DET,E1,E2,E3,H,NDM)  !Jacobian}gbNX̍쐬
c	IF(IERSW .EQ. 1) RETURN
C
      FAC1=WT*DET
      FAC=DSQRT(FAC1)
      DO 20 I=1,ND
   20 B(I)=FAC*B(I)
C
C-------------------- COMPUTE PRESSURE HEAD AT INTEGRATION POINT (R,S,T)
C
      SCOD=0.D00
      DO 30 I=1,IEL
      II=NODE(I,N)
      SCOD=SCOD+P(II)*H(I)  !vf̕ϐ
   30 CONTINUE
      CM=SCOD
C
C---------- BASED ON PRESSURE HEAD AT INTEGRATION POINT(CM), CONPUTE THE
C           PRESSURE HEAD DEPENDENT CONDUCTIVITIES AND SPECIFIC MOISTURE
C           CONTENT
C
      CPEC=0.D00  !Oa
      RPEK=1.D00
      TIK22=POR(M)
      IF( CM .LT. 0.D00 ) THEN
      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP)  !sOa
      CALL INTERP (XK,YK,TETA, RPEK,NUMK(M),NUMMAT,M,MK)
      CALL INTERP (XC,YC,TETA,CPEC,NUMC(M),NUMMAT,M,MP)
       WET=0.0D00
       IF(RPEK .LE. 1.0D-20) RPEK=1.0D-20
       IF(CPEC .LE. 0.0) CPEC=0.0
      END IF
C
       COND1(1,1)=COND(1,1)*RPEK  !W
       COND1(2,1)=COND(2,1)*RPEK
       COND1(3,1)=COND(3,1)*RPEK
       COND1(1,2)=COND(1,2)*RPEK
       COND1(2,2)=COND(2,2)*RPEK
       COND1(3,2)=COND(3,2)*RPEK
       COND1(1,3)=COND(1,3)*RPEK
       COND1(2,3)=COND(2,3)*RPEK
       COND1(3,3)=COND(3,3)*RPEK
C
  110 DO 50 II=1,IEL
      I=3*II
      I1=I-1
      I2=I-2
      DO 40 JJ=1,IEL
      J=3*JJ
      J1=J-1
      J2=J-2                            
      BB1=B( I2)*(COND1(1,1)*B(J2)+COND1(1,2)*B(J1)+COND1(1,3)*B(J))
      BB2=B( I1)*(COND1(2,1)*B(J2)+COND1(2,2)*B(J1)+COND1(2,3)*B(J))
      BB3=B( I )*(COND1(3,1)*B(J2)+COND1(3,2)*B(J1)+COND1(3,3)*B(J))
   40 E(II,JJ)=E(II,JJ)+(BB1+BB2+BB3)  ![A]}gbNX
      K2=NODE(II,N)
      BB4=COND1(1,3)*B(I2)+COND1(2,3)*B(I1)+COND1(3,3)*B(I)
      BB4=BB4*FAC
      BB(K2)=BB(K2)+BB4      ![B]}gbNX
      B1=0.D00
      B1=TIK22*CMUL*WET
      AA=CPEC+B1
      AA=AA*FAC1
      D(K2)=D(K2)+AA*H(II)     ![F]}gbNX
   50 CONTINUE
   10 CONTINUE
C
C
C----------------------------- ADD ELEMENT CONTRIBUTION TO A(N,M) MATRIX
C      vf}gbNX̑S̃}gbNXւ̊i[
      CALL SETAM(IS,NODE,ISP,A,E,
     &                  NWK,NUMEL,NUMNP1,MXNODS,IELM,IEL,N)
      RETURN
      END
      SUBROUTINE QUADS2A (A,BB,D,NODE,B,XYZ,E,COND,ND,NDM,NUMNP,NUMNP1,
     1                   NWK,IELM,CMUL, WET,N,MXNODS,NUMEL,ISP,IS,
     2                   P,XK,YK,XP,YP,XC,YC,NUMMAT,MK,MP,M)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@Opvf̗vf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON  /MAT/   CONS1,CONS2,C1(99),C2(99),C3(99),SS(99),POR(99),
     1                NUMK(99),NUMP(99),NUMC(99)
      COMMON /THREED/IELD,IEL
      COMMON /TH1/ NINT,NINTZ
	COMMON / NEGAE / IERSW 
C
      DIMENSION A(NWK),BB(NUMNP),D(NUMNP),NODE(MXNODS,NUMEL),
     1          B(NDM),XYZ(NDM),E(IELM,IELM),ISP(NWK),
     2          IS(NUMNP1),XG(4,4),WGT(4,4),COND(3,3),COND1(3,3),H(8),
     3          XK(MK,NUMMAT),YK(MK,NUMMAT),XP(MP,NUMMAT),YP(MP,NUMMAT),
     4          XC(MP,NUMMAT),YC(MP,NUMMAT),P(NUMNP)
C
      DIMENSION ALL1(3),ALL2(3,3),ALL4(3,7),
     1          ALW1(1),ALW2(3)  ,ALW4(7) 
C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
C
      DATA WGT / 2.000,             0.,             0.,             0.,
     1 1.0000000000000,1.0000000000000,             0.,             0.,
     2  .5555555555556, .8888888888889, .5555555555556,             0.,
     3  .3478548451375, .6521451548625, .6521451548625, .3478548451375/
C
      DATA ALL1/
     1 0.3333333333333,0.3333333333333,0.3333333333333/
C
      DATA ALL2/
     1 0.6666666666667,0.1666666666667,0.1666666666667,
     2 0.1666666666667,0.6666666666667,0.1666666666667,
     3 0.1666666666667,0.1666666666667,0.6666666666667/
C
      DATA ALL4/
     1 0.3333333333333,0.3333333333333,0.3333333333333,
     1 0.0597158717   ,0.4701420641   ,0.4701420641   ,
     2 0.4701420641   ,0.0597158717   ,0.4701420641   ,
     3 0.4701420641   ,0.4701420641   ,0.0597158717   ,
     4 0.7974269853   ,0.1012865073   ,0.1012865073   ,
     5 0.1012865073   ,0.7974269853   ,0.1012865073   ,
     6 0.1012865073   ,0.1012865073   ,0.7974269853   /
C
      DATA ALW1/  1.0   /
C
      DATA ALW2/
     1 0.3333333333333,0.3333333333333,0.3333333333333/
C
      DATA ALW4 /
     1 0.2250000000   ,0.1323941527   ,0.1323941527     ,
     2 0.1323941527   ,0.1259391805   ,0.1259391805     ,
     3 0.1259391805   /
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      NNINT = NINT
      IF(NINT .EQ. 2) NNINT = 3
      IF(NINT .EQ. 3) NNINT = 7
      IF(NINT .EQ. 4) NNINT = 7
C
      DO 10 LX=1,NNINT
C                                             NINT =1
      IF(NINT .NE. 1) GO TO 1
      AL1=ALL1(1)    !KEXϕ̍W
      AL2=ALL1(2)    !KEXϕ̍W
      AL3=ALL1(3)    !KEXϕ̍W
      ALWW=ALW1(1)/2. !KEXϕ̏d
      GO TO 9
    1 CONTINUE
C
C                                             NINT =2
      IF(NINT .NE. 2) GO TO 2
      AL1=ALL2(1,LX)
      AL2=ALL2(2,LX)
      AL3=ALL2(3,LX)
      ALWW=ALW2(LX)/2.
      GO TO 9
    2 CONTINUE
C
C                                             NINT =3
      IF(NINT .NE. 3) GO TO 3
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
      ALWW=ALW4(LX)/2.
      GO TO 9
    3 CONTINUE
C
C                                             NINT =4
      IF(NINT .NE. 4) GO TO 9
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
      ALWW=ALW4(LX)/2.
    9 CONTINUE
C
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ) !KEXϕ̍W
      WT=ALWW*WGT(LZ,NINTZ) !KEXϕ̏d
C
C @@@@@@@@Jacobian}gbNX̍쐬
      CALL DERIQ2(XYZ,B,DET,AL1,AL2,AL3,E3,H,NDM)
c	IF(IERSW .EQ. 1) RETURN
C
      FAC1=WT*DET
      FAC=DSQRT(FAC1)
      DO 20 I=1,ND
   20 B(I)=FAC*B(I)
C
C-------------------- COMPUTE PRESSURE HEAD AT INTEGRATION POINT (R,S,T)
C
      SCOD=0.D00
      DO 30 I=1,IEL
      II=NODE(I,N)
      SCOD=SCOD+P(II)*H(I) !vf̕ϐ
   30 CONTINUE
      CM=SCOD
C
C---------- BASED ON PRESSURE HEAD AT INTEGRATION POINT(CM), CONPUTE THE
C           PRESSURE HEAD DEPENDENT CONDUCTIVITIES AND SPECIFIC MOISTURE
C           CONTENT
C
      CPEC=0.D00 !Oa
      RPEK=1.D00
      TIK22=POR(M)
      IF( CM .LT. 0.D00 ) THEN
      CALL INTERP (YP,XP,CM,TETA,NUMP(M),NUMMAT,M,MP) !sOa
      CALL INTERP (XK,YK,TETA, RPEK,NUMK(M),NUMMAT,M,MK)
      CALL INTERP (XC,YC,TETA,CPEC,NUMC(M),NUMMAT,M,MP)
       WET=0.0D00
       IF(RPEC .LE. 1.0D-20) RPEC=1.0D-20
       IF(CPEC .LE. 0.0) CPEC=0.0
      END IF
C
       COND1(1,1)=COND(1,1)*RPEK  !W
       COND1(2,1)=COND(2,1)*RPEK
       COND1(3,1)=COND(3,1)*RPEK
       COND1(1,2)=COND(1,2)*RPEK
       COND1(2,2)=COND(2,2)*RPEK
       COND1(3,2)=COND(3,2)*RPEK
       COND1(1,3)=COND(1,3)*RPEK
       COND1(2,3)=COND(2,3)*RPEK
       COND1(3,3)=COND(3,3)*RPEK
C
  110 DO 50 II=1,IEL
      I=3*II
      I1=I-1
      I2=I-2
      DO 40 JJ=1,IEL
      J=3*JJ
      J1=J-1
      J2=J-2
      BB1=B( I2)*(COND1(1,1)*B(J2)+COND1(1,2)*B(J1)+COND1(1,3)*B(J))
      BB2=B( I1)*(COND1(2,1)*B(J2)+COND1(2,2)*B(J1)+COND1(2,3)*B(J))
      BB3=B( I )*(COND1(3,1)*B(J2)+COND1(3,2)*B(J1)+COND1(3,3)*B(J))
   40 E(II,JJ)=E(II,JJ)+(BB1+BB2+BB3)  ![A]}gbNX
      K2=NODE(II,N)
      BB4=COND1(1,3)*B(I2)+COND1(2,3)*B(I1)+COND1(3,3)*B(I)
      BB4=BB4*FAC
      BB(K2)=BB(K2)+BB4     ![B]}gbNX
      B1=0.D00
      B1=TIK22*CMUL*WET
      AA=CPEC+B1
      AA=AA*FAC1
      D(K2)=D(K2)+AA*H(II)   ![F]}gbNX
   50 CONTINUE
   10 CONTINUE
C
C----------------------------- ADD ELEMENT CONTRIBUTION TO A(N,M) MATRIX
C      vf}gbNX̑S̃}gbNXւ̊i[
      CALL SETAM(IS,NODE,ISP,A,E,
     &                  NWK,NUMEL,NUMNP1,MXNODS,IELM,IEL,N)
      RETURN
      END
C
      SUBROUTINE MESHERR (X,Y,Z,NODE,MXNODS,ITYPE,
     2                  NUMNP,NUMEL,IERSW)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C  evf}gbNX̍쐬
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /TH1/ NINT,NINTZ
      COMMON /THREED/ IELD,IEL
C
      DIMENSION  X(NUMNP),Y(NUMNP),Z(NUMNP),NODE(MXNODS,NUMEL),
     1            B1(24),XYZ(24),E(64),ITYPE(NUMEL)
C
      NDM = 24
C
	   IERSW = 0
      DO 70 N=1, NUMEL
C 
       IELD = ITYPE(N)
       IELM=IELD
       IEL=IELD
       ND=3*IELD
       I2=0
C ---------------------------------------------------------------------------
      DO K=1, IEL
      IF(NODE(K,N) .GT. NUMNP) THEN
	   IERSW = 1
	   write(NPMT6,*) "ERROR ELEMENT =",N," : NODE NUMBER ERROR "
      END IF
      END DO
C
      DO K=1,IEL
      DO KK=1,IEL
      IF(K .NE. KK .AND. NODE(K,N) .EQ. NODE(KK,N)) THEN
	   IERSW = 1
	   write(NPMT6,*) "ERROR ELEMENT =",N," : NODE NUMBER ERROR "
      END IF
      END DO
      END DO
C ---------------------------------------------------------------------------
       DO 60  I=1,IEL
        II=NODE(I,N)
        I2=I2+3
        XYZ(I2-2)=X(II) !W̊i[
        XYZ(I2-1)=Y(II)
        XYZ( I2 )=Z(II)
   60  continue
C
       IEDET= 0
       IF(IELM .EQ. 8) THEN
C @@@6ʑ̗vf̃}gbNX̍쐬
      CALL QUADS3C( XYZ,NDM,IELM,DET,IEDET)
      ELSEIF(IELM .EQ. 6) THEN
C @@@3pvf̃}gbNX̍쐬
      CALL QUADS2C( XYZ,NDM,IELM,DET,IEDET)
      END IF
C
      IF (IEDET .EQ. 1 ) THEN
       WRITE(NPMT6,*) "ERROR ELEMENT =",N," : AREA IS NEGATIVE "
	   IERSW = 1
       END IF
C
  70  CONTINUE
C
C      IF(IERSW .EQ. 1 ) STOP
      RETURN
      END
      SUBROUTINE QUADS3C (XYZ,NDM,IELM,DET,IEDET)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@6ʑ̗vf̗vf}gbNX̍쐬
C
      COMMON /TH1/ NINT,NINTZ
C
      DIMENSION XYZ(NDM),XG(4,4),H(8)
      DIMENSION XJ(3,3),P(3,8 )

C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      DET = 0.0
      DO 10 LX=1,NINT
      E1=XG(LX,NINT)     !KEXϕ̍W
      DO 10 LY=1,NINT
      E2=XG(LY,NINT)     !KEXϕ̍W
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ)    !KEXϕ̍W
C      WT=WGT(LX,NINT)*WGT(LY,NINT)*WGT(LZ,NINTZ)   !KEXϕ̏d
C
      CALL FUNCT (E1,E2,E3,H,P,XJ,DET,XYZ)  !Jacobian}gbNX̍쐬
      IF (DET.LE. 1.0D-8 ) 	IEDET =1 
   10 CONTINUE
      RETURN
      END
      SUBROUTINE QUADS2C (XYZ,NDM,IELM,DET,IEDET)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C @@@Opvf̗vf}gbNX̍쐬
C
      COMMON /TH1/ NINT,NINTZ
C
      DIMENSION XYZ(NDM),XG(4,4),H(8)
      DIMENSION XJ(3,3),P(3,8 )
C
      DIMENSION ALL1(3),ALL2(3,3),ALL4(3,7)
C
      DATA XG /     0.,             0.,             0.,             0.,
     1 -.5773502691896, .5773502691896,             0.,             0.,
     2 -.7745966692415, .0000000000000, .7745966692415,             0.,
     3 -.8611363115941,-.3399810435849, .3399810435849, .8611363115941/
      DATA ALL1/
     1 0.3333333333333,0.3333333333333,0.3333333333333/
C
      DATA ALL2/
     1 0.6666666666667,0.1666666666667,0.1666666666667,
     2 0.1666666666667,0.6666666666667,0.1666666666667,
     3 0.1666666666667,0.1666666666667,0.6666666666667/
C
      DATA ALL4/
     1 0.3333333333333,0.3333333333333,0.3333333333333,
     1 0.0597158717   ,0.4701420641   ,0.4701420641   ,
     2 0.4701420641   ,0.0597158717   ,0.4701420641   ,
     3 0.4701420641   ,0.4701420641   ,0.0597158717   ,
     4 0.7974269853   ,0.1012865073   ,0.1012865073   ,
     5 0.1012865073   ,0.7974269853   ,0.1012865073   ,
     6 0.1012865073   ,0.1012865073   ,0.7974269853   /
C
C--------------------------------------------- FIND STIFFNESS OF ELEMENT
C
C     INTEGRATE  A ( N,M ) ,F(N,M), B( N)
C
C-----------------------------------------------------------------------
C
      DET = 0.0
      NNINT = NINT
      IF(NINT .EQ. 2) NNINT = 3
      IF(NINT .EQ. 3) NNINT = 7
      IF(NINT .EQ. 4) NNINT = 7
C
      DO 10 LX=1,NNINT
C                                             NINT =1
      IF(NINT .NE. 1) GO TO 1
      AL1=ALL1(1)    !KEXϕ̍W
      AL2=ALL1(2)    !KEXϕ̍W
      AL3=ALL1(3)    !KEXϕ̍W
      GO TO 9
    1 CONTINUE
C
C                                             NINT =2
      IF(NINT .NE. 2) GO TO 2
      AL1=ALL2(1,LX)
      AL2=ALL2(2,LX)
      AL3=ALL2(3,LX)
      GO TO 9
    2 CONTINUE
C
C                                             NINT =3
      IF(NINT .NE. 3) GO TO 3
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
      GO TO 9
    3 CONTINUE
C
C                                             NINT =4
      IF(NINT .NE. 4) GO TO 9
      AL1=ALL4(1,LX)
      AL2=ALL4(2,LX)
      AL3=ALL4(3,LX)
    9 CONTINUE
C
      DO 10 LZ=1,NINTZ
      E3=XG(LZ,NINTZ) !KEXϕ̍W
C
C @@@@@@@@Jacobian}gbNX̍쐬
      CALL FUNCT2(AL1,AL2,AL3,E3,H,P,XJ,DET,XYZ)
      IF (DET.LE. 1.0D-8 ) 	IEDET =1 
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE PLODAT2 ( P,Q,KODE,NUMNP,NUMEL)
      IMPLICIT REAL*8 ( A-H,O-Z )
C
C@vZʂ̃t@CóiP,Q,Vx,Vy,Vz,KODE)
C
      CHARACTER*5  INCHA,INCHAO
      COMMON  /NPMT/  NPMT6,INCHA
      COMMON /MTNOMB/ IFIL,NOTAPP,NOTAPR,INCOR,NDPR,ITAP
C     ***********************************************************
C     *     THIS IS SUBROUTINE TO MEMORY PLOTTER DATA           *
C     ***********************************************************
C
      DIMENSION P(NUMNP),KODE(NUMNP),Q(NUMNP) 
C
      LA=0
      TIME=0.0
      DD1 = 0.0
  200 CONTINUE
      IF( ITAP .EQ. 0 ) THEN
       WRITE(NOTAPP,*) LA,TIME
       WRITE(NOTAPP,*)(P(I),Q(I),KODE(I),I=1,NUMNP)
       WRITE(NOTAPP,*)(DD1,DD1,DD1,I=1,NUMEL)
      ELSE
       WRITE(NOTAPP) LA,TIME
       WRITE(NOTAPP) P
      END IF
   10 FORMAT(20A4,5I5,E15.7)
   20 FORMAT(3E15.7)
   30 FORMAT(8I5)
   40 FORMAT(I5,E15.7,I5)
      RETURN
      END